(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(*  I|oC葱CR}hCIvV *)

unit COption;

interface

uses Variable,PRMIn,Display,Data,DataScal,IOProc,DosCall,SysUtils,Windows;

Type Real=Double;

Procedure GetOption(Str:String;Fil:Integer);
function  OptionCheck(Str:String;Fil:Integer):Boolean;
procedure CmdRead;
procedure MakePStr(CmdLine:String);

var PCount :Integer;
    PStr : array [0..255] of ^String;

implementation

procedure MakePStr(CmdLine:String);
var i,j,k,len,count:Integer;
    newstr:Boolean;
begin
  for i:=0 to 255 do PStr[i]:=NIL;
  i:=1;
  k:=-1;
  len:=Length(CmdLine);
  newstr:=True;
  while (i<=len) and (CmdLine[i]=' ') do Inc(i);
  while (i<=len) do begin
    if (newstr) then begin
      Inc(k);
      GetMem(PStr[k],SizeOf(String));
      PStr[k]^:='';
    end;
    if (CmdLine[i]='"') then begin
      Inc(i);
      j:=i;
      while (j<=len) and (CmdLine[j]<>'"') do Inc(j);
    end else begin
      j:=i;
      while (j<=len) and (CmdLine[j]<>' ') do Inc(j);
    end;
    count:=j-i;
    if (count>0) then PStr[k]^:=PStr[k]^+Copy(CmdLine,i,count);
    if (j<len) and (CmdLine[j]='"') and (CmdLine[j+1]=' ') then newstr:=True
    else if (j<=len) and (CmdLine[j]=' ') then newstr:=True
    else newstr:=False;
    i:=j+1;
    while (i<=len) and (CmdLine[i]=' ') do Inc(i);
  end;
  PCount:=k;
end;

procedure GetOption(Str:String;Fil:Integer);
var Error:Boolean;
    i,po,Len:Integer;
    S:String;
begin
  Error:=False;
  i:=1;
  Len:=Length(Str);
  While i<=Len do begin
      While (i<=Len) and (Str[i]=' ') do Inc(i);
      S:=Copy(Str,i,Len-i+1);
      po:=Pos(' ',S);
      if po=0 then po:=Length(S)+1;
      S:=Copy(S,1,po-1);
      if Length(S)>=2 then begin
          if S[1] in ['-','/'] then begin
              if not OptionCheck(S,Fil) then Error:=True;
          end else Error:=True;
      end;
      Inc(i,po);
  end;
  if Error then ErrorDisp('Warning: Invalid command option.');
end;

function  OptionCheck(Str:String;Fil:Integer):Boolean;
var S,S2:String;
    code,po,Axis,ScType:Integer;
    Error:Boolean;
    a,mi,ma,sc:Real;
begin
  With FilePar.Body[Fil] do begin
    Error:=False;
    code:=0;
    if (UpCase(Str[2]) in ['X','Y','S','R','F','D','O','T','L','W','C']) then
        S:=Copy(Str,3,Length(Str)-2)
    else if (UpCase(Str[2]) in ['E','V','Z','M']) then
        S:=Copy(Str,4,Length(Str)-3)
    else Error:=True;
    if (UpCase(Str[2])<>'E') and (Length(S)=0) then Error:=True
    else begin
      case UpCase(Str[2]) of
        'X' : begin
                Val(S,a,code);
                if code=0 then hax:=Round(RangeCheck(a,0,99));
              end;
        'Y' : begin
                Val(S,a,code);
                if code=0 then vax:=Round(RangeCheck(a,0,99));
              end;
        'S' : begin
                Val(S,a,code);
                if code=0 then SkipNum:=ABS(Round(a));
              end;
        'R' : begin
                Val(S,a,code);
                if code=0 then ReadStep:=ABS(Round(a));
              end;
        'F' : begin
                Val(S,a,code);
                if code=0 then FinalLine:=Round(a);
                if FinalLine<-1 then FinalLine:=-1;
              end;
        'D' : begin
                if S[1] in ['A'..'Z'] then DotTyp:=Ord(S[1])-Ord('A')
                else if S[1] in ['a'..'z'] then DotTyp:=Ord(S[1])-Ord('a')+26
                else Error:=True;
              end;
        'O' : begin
                Val(S,a,code);
                if code=0 then DotSize:=Round(RangeCheck(a,1,2000));
              end;
        'T' : begin
                Val(S,a,code);
                if code=0 then DotAttr:=Round(RangeCheck(a,0,3));
              end;
        'L' : begin
                Val(S,a,code);
                if code=0 then DottedSize:=Round(RangeCheck(a,1,1000));
              end;
        'W' : begin
                Val(S,a,code);
                if code=0 then DotWidth:=Round(RangeCheck(a,1,1000));
              end;
        'C' : begin
                Val(S,a,code);
                if code=0 then DotCol:=Round(RangeCheck(a,0,7));
              end;
        'V' : case Upcase(Str[3]) of
                  'X':begin
                        Val(S,a,code);
                        if code=0 then Smoothingx:=Round(RangeCheck(a,0,50));
                      end;
                  'Y':begin
                        Val(S,a,code);
                        if code=0 then Smoothingy:=Round(RangeCheck(a,0,50));
                      end;
                  else Error:=True;
              end;
        'E' : begin
                case Upcase(Str[3]) of
                  'X': begin
                         Axis:=0;
                         Axisx:=0;
                       end;
                  'Y': begin
                         Axis:=1;
                         Axisy:=0;
                       end;
                  'U': begin
                         Axis:=2;
                         Axisx:=1;
                       end;
                  'R': begin
                         Axis:=3;
                         Axisy:=1;
                       end;
                  else Error:=True;
                end;
                if S<>'' then begin
                  ScType:=AxisPar[Axis].ScType;
                  Val(S,a,code);
                  if code=0 then begin
                    AxisPar[Axis].ScType:=Round(RangeCheck(a,0,2));
                    if ScType<>AxisPar[Axis].ScType then With AxisPar[Axis] do begin
                        Min:=-1;
                        Max:=1;
                        Scale:=1;
                        SetMin:=False;
                        SetMax:=False;
                        SetScale:=False;
                    end;
                  end;
                end;
              end;
        'Z' : begin
                case Upcase(Str[3]) of
                  'X': Axis:=0;
                  'Y': Axis:=1;
                  'U': Axis:=2;
                  'R': Axis:=3;
                  else Error:=True;
                end;
                po:=Pos(',',S);
                if po=0 then Error:=True
                else begin
                    S2:=Copy(S,1,po-1);
                    Val(S2,mi,code);
                    if code<>0 then Error:=True;
                end;
                S:=Copy(S,po+1,Length(S)-po);
                po:=Pos(',',S);
                if po=0 then Error:=True
                else begin
                    S2:=Copy(S,1,po-1);
                    Val(S2,ma,code);
                    if code<>0 then Error:=True;
                end;
                S:=Copy(S,po+1,Length(S)-po);
                Val(S,sc,code);
                if code<>0 then Error:=True;
                With AxisPar[Axis] do begin
                    Min:=mi;
                    Max:=ma;
                    Scale:=sc;
                    SetMin:=True;
                    SetMax:=True;
                    SetScale:=True;
                    ConvScale(True,ScType,Min,Max,Scale);
                    CheckMinMax(ScType,Min,Max,True,True);
                    CheckScale(ScType,Min,Max,Scale,True);
                end;
              end;
        'M' : if Upcase(Str[3])='X' then ModX:=S
              else if Upcase(Str[3])='Y' then ModY:=S
              else Error:=True;
        else Error:=True;
      end;
    end;
    if (code<>0) or Error then OptionCheck:=False
                          else OptionCheck:=True;
  end;
end;

Var DGSYS_QuitSave:procedure;

procedure DispUsage;
var M:array[0..65*22] of Char;
    Len,Po:Integer;
    S:String;
begin
    Po:=0;
    Len:=Length(DGSYS.Main);
    Move(DGSYS.Main[1],M[Po],Len);
    Inc(Po,Len);
    S:='ver. 5.41 ';
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    Len:=Length(DGSYS.Copyright);
    Move(DGSYS.Copyright[1],M[Po],Len);
    Inc(Po,Len);
    S:=Char($0D)+'Usage: DG [ [-option1] [filename1] [-option2] [filename2] ... ]'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='Options: -x{0..99}       data No. (abscissas)'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -y{0..99}       data No. (ordinates)'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -d{A..Z,a..z}   Dot type'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -o{1..2000}     dOt size'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -t{0..3}        sTyle of line'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -l{1..1000}     Length of dotted line'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -w{1..1000}     Width of line'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -c{0..7}        Color'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -v{x|y}{0..50}  neighbour aVarege'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -s{0..}         Skip head lines'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -r{1..}         Read step'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -f{-1..}        Final line'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -m{x|y}{Math}   Math formula'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -p{FileName}    load Parameter file'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -a              disable Auto-run'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -g              Get parameters from files'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -i{Directory}   Initial directory'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -e{x|y|u|r}{0..2}  scale type'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -z{x|y|u|r}{min,max,inc} scale'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    S:='         -?, -h          display options'+Char($0D);
    Len:=Length(S);
    Move(S[1],M[Po],Len);
    Inc(Po,Len);
    M[Po]:=Char(0);
    Windows.MessageBox(0,@M,'Ngraph',MB_OK);
    DGSYS_QuitSave;
end;

procedure CmdRead;
var  i,j,more:Integer;
     Error:Boolean;
     PS,SName:String;
     Com:ComType;

           function  WildExpand(Fil:PathStr):Integer;
           var more:Integer;
               Dir:DirStr;
               Name:NameStr;
               Ext:ExtStr;
               Dat:TSearchRec;
               Ch:Char;
               Error:Integer;
           begin
                FSplit(Fil,Dir,Name,Ext);
                more:=0;
                Error:=FindFirst(fil,faArchive or faReadOnly,dat);
                if Error<>0 then ErrorDisp('Error: File ('+fil+') not found.')
                else
                     while (Error=0) and ((FilePar.Num+more)<Maxfil) do begin
                         Inc(more);
                         FilePar.Body[FilePar.Num+more].Name:=FExpand(Dir+dat.Name);
                         Error:=FindNext(dat);
                     end;
                SysUtils.FindClose(dat);
                WildExpand:=more;
           end;

	   function Check(Str:String):Boolean;
	   var S:String;
               IOError:Boolean;
	   begin
             Check:=True;
	     S:=Copy(Str,3,Length(Str)-2);
	     case Upcase(Str[2]) of
	       'P' : if (S<>'') then ParamIn(S)
                                else Check:=False;
               'A' : DGSYS.AutoRun:=False;
               'G' : DGSYS.FileOption:='Yes ';
               'I' : begin
                       DGSYS.ActivDir:=S;
                       ChDir(DGSYS.ActivDir);
                       Error:=IOErrorCheck;
                       GetDir(0,DGSYS.ActivDir);
                     end;
	       'H','?' : Check:=False;
	       else begin
		      ErrorDisp('Error:Unknown/Illegal option -'+Upcase(Str[2]));
	              Check:=False;
		     end;
	     end;
           end;

begin
    FilePar.Body[maxfil+1]:=FilePar.Body[0];
    Error:=False;
    for i:=1 to PCount do begin
        PS:=PStr[i]^;
        if (PS[1] in ['-','/']) then begin
            if not OptionCheck(PS,maxfil+1) then begin
                if not Check(PS) then Error:=True;
            end;
        end else begin
	     more:=WildExpand(PS);
	     for j:=1 to more do if FilePar.Num<maxfil then begin
                 Inc(FilePar.Num);
                 FilePar.Body[maxfil+1].Name:=FilePar.Body[FilePar.Num].Name;
                 FilePar.Body[FilePar.Num]:=FilePar.Body[maxfil+1];
                 if (DGSYS.FileOption[1]='Y') then begin
                     if Get5Line(j,Com) then begin
                         GetOption(Com[1],j);
                         if FilePar.Body[j].SkipNum=0 then FilePar.Body[j].SkipNum:=1;
                     end else Dec(FilePar.Num);
                 end;
             end;
        end;
    end;
    if Error then begin
        DGSYS_QuitSave:=DGSYS.Quit;
        DGSYS.Quit:=DispUsage;
        DGQuit('');
    end;
end;

end.
