(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* f[^t@Cǂݍݎ葱 *)

unit DATA;

interface

uses Crt,Math,Variable,Display,DataScal,IOProc,SysUtils;

Type Real=Double;
     ComType = Array[1..5] of String;

procedure GetMinMax(fil:Integer;var sminx,sminy,smaxx,smaxy:Real);
function  InterplitMath(S:String;var Code:MathCodeType; var Maxdim:Integer;var NeedData:ByteSet;var Need2Pass:Boolean;
                        DotTyp,hax,vax:Integer;
                        AllowCol,AllowMemory,AllowX,AllowY,AllowUser:Boolean):Boolean;
function  Calculate(Code:MathCodeType;x,y,Minx,Miny,Maxx,Maxy:Real;XStatus,YStatus:ShortInt;
                   var MathData;var MathStatus;var Memory,IntegData,DefData;var DefFirst;
                   var Value:Real):Integer;
function  OpenData(fil:Integer):Boolean;
function  UseData(Num:Integer):Boolean;
procedure CloseData;
function  Get5Line(fil:Integer;var Com:ComType):Boolean;
function  GetData(var x,y:Real;var LinePos:LongInt;var NAN:Boolean):Boolean;

const EndOfData :Boolean=True;

var DataNum   :LongInt;
    AxisRawMode,DataRawMode:Boolean;

implementation

Const DataFile:Integer=0;

var FPdata :Text;
    DataPo,DataPo2,DataPoMax,MaxDim,Smooth :Integer;
    FirstData,ComRead,NewRead,MathError,LogError :Boolean;
    LineNum :LongInt;
    NeedData:ByteSet;
    UserFnIntp:Array [0..1] of Integer;
    NMinx,NMinY,NMaxx,NMaxy:Real;

procedure GetMinMax2(var sminx,sminy,smaxx,smaxy:Real);
var x,y:Real;
    SetMinMax:Boolean;
    Lin:LongInt;
    NAN:Boolean;
begin
    SetMinMax:=False;
    while GetData(x,y,Lin,NAN) do if not NAN then begin
        if not SetMinMax then begin
             smaxx:=x;
             sminx:=x;
             smaxy:=y;
             sminy:=y;
             SetMinMax:=True;
        end else begin
            if x>smaxx then smaxx:=x;
            if x<sminx then sminx:=x;
            if y>smaxy then smaxy:=y;
            if y<sminy then sminy:=y;
        end;
    end;
end;

procedure GetMinMax(fil:Integer;var sminx,sminy,smaxx,smaxy:Real);
begin
    sminx:=0;
    sminy:=0;
    smaxx:=0;
    smaxy:=0;
    if OpenData(fil) then GetMinMax2(sminx,sminy,smaxx,smaxy);
    CloseData;
end;

Const OperatorNum=56;

Const OperatorTable : Array[1..OperatorNum] of Record
                                        Op:String[6];
                                        Cd:Char;
                                        Arg:Byte;
                                      end = (
             (Op:'ABS('  ;Cd:'A'; Arg:1),
             (Op:'SIGN(' ;Cd:'B'; Arg:1),
             (Op:'INT('  ;Cd:'C'; Arg:1),
             (Op:'FRAC(' ;Cd:'D'; Arg:1),
             (Op:'ROUND(';Cd:'E'; Arg:1),
             (Op:'SQR('  ;Cd:'F'; Arg:1),
             (Op:'SQRT(' ;Cd:'G'; Arg:1),
             (Op:'EXP('  ;Cd:'H'; Arg:1),
             (Op:'LN('   ;Cd:'I'; Arg:1),
             (Op:'LOG('  ;Cd:'J'; Arg:1),
             (Op:'SIN('  ;Cd:'K'; Arg:1),
             (Op:'COS('  ;Cd:'L'; Arg:1),
             (Op:'TAN('  ;Cd:'M'; Arg:1),
             (Op:'ASIN(' ;Cd:'N'; Arg:1),
             (Op:'ACOS(' ;Cd:'O'; Arg:1),
             (Op:'ATAN(' ;Cd:'P'; Arg:1),
             (Op:'SINH(' ;Cd:'Q'; Arg:1),
             (Op:'COSH(' ;Cd:'R'; Arg:1),
             (Op:'TANH(' ;Cd:'S'; Arg:1),
             (Op:'ASINH(';Cd:'T'; Arg:1),
             (Op:'ACOSH(';Cd:'U'; Arg:1),
             (Op:'ATANH(';Cd:'V'; Arg:1),
             (Op:'THETA(';Cd:'W'; Arg:1),
             (Op:'DELTA(';Cd:'Z'; Arg:1),
             (Op:'GAUSS(';Cd:'a'; Arg:1),
             (Op:'GAMMA(';Cd:'b'; Arg:1),
             (Op:'ICGAM(';Cd:'c'; Arg:2),
             (Op:'ERFC(' ;Cd:'d'; Arg:1),
             (Op:'EI('   ;Cd:'e'; Arg:1),
             (Op:'BETA(' ;Cd:'f'; Arg:2),
             (Op:'JN('   ;Cd:'g'; Arg:2),
             (Op:'YN('   ;Cd:'h'; Arg:2),
             (Op:'MIN('  ;Cd:'i'; Arg:2),
             (Op:'MAX('  ;Cd:'j'; Arg:2),
             (Op:'EQ('   ;Cd:'k'; Arg:2),
             (Op:'NEQ('  ;Cd:'l'; Arg:2),
             (Op:'GE('   ;Cd:'m'; Arg:2),
             (Op:'GT('   ;Cd:'n'; Arg:2),
             (Op:'LE('   ;Cd:'o'; Arg:2),
             (Op:'LT('   ;Cd:'p'; Arg:2),
             (Op:'NOT('  ;Cd:'q'; Arg:1),
             (Op:'OR('   ;Cd:'r'; Arg:2),
             (Op:'AND('  ;Cd:'s'; Arg:2),
             (Op:'XOR('  ;Cd:'t'; Arg:2),
             (Op:'RAND(' ;Cd:'u'; Arg:1),
             (Op:'PN('   ;Cd:'v'; Arg:2),
             (Op:'LGN('  ;Cd:'w'; Arg:3),
             (Op:'HN('   ;Cd:'x'; Arg:2),
             (Op:'TN('   ;Cd:'y'; Arg:2),
             (Op:'M('    ;Cd:'{'; Arg:2),
             (Op:'RM('   ;Cd:'}'; Arg:1),
             (Op:'INTEG(';Cd:'['; Arg:1),
             (Op:'DIF('  ;Cd:']'; Arg:1),
             (Op:'F('    ;Cd:Chr($A0); Arg:2),
             (Op:'G('    ;Cd:Chr($A1); Arg:2),
             (Op:'IF('   ;Cd:'?'; Arg:3) );

function InterplitMath(S:String;var Code:MathCodeType; var Maxdim:Integer;var NeedData:ByteSet;var Need2Pass:Boolean;
                       DotTyp,hax,vax:Integer;
                       AllowCol,AllowMemory,AllowX,AllowY,AllowUser:Boolean):Boolean;
var i,j,Len,Er,Po,Po2,IntegDataPo,DefDataPo,Dim:Integer;
    x:Real;
    Find:Boolean;
    S2:String;
begin
    InterplitMath:=False;
    IntegDataPo:=0;
    DefDataPo:=0;
    Need2Pass:=False;
    j:=0;
    for i:=1 to Length(S) do
        if S[i]<>' ' then begin
            Inc(j);
            S[j]:=S[i]
        end;
    S[0]:=Chr(j);
    for i:=1 to Length(S) do S[i]:=Upcase(S[i]);
    if S[Length(S)]<>'=' then S:=S+'=';
    if S[Length(S)]<>'=' then exit;
    Po:=1;
    Po2:=0;
    Len:=Length(S);
    While (Po<=Len) do begin
        if S[Po]='=' then begin
            if Po2>SizeOf(Code) then exit;
            Code[Po2]:='=';
            Inc(Po2);
            Inc(Po);
        end else if S[Po] in ['0'..'9','.'] then begin
            i:=1;
            While (S[Po+i] in ['0'..'9','.','E'])
               or (S[Po+i] in ['+','-']) and (S[Po+i-1]='E') do Inc(i);
            S2:=Copy(S,Po,i);
            Val(S2,x,Er);
            if (Er<>0) or (Po2+SizeOf(Real)>SizeOf(Code)) then exit;
            Code[Po2]:='#';
            Move(x,Code[Po2+1],SizeOf(Real));
            Inc(Po2,SizeOf(Real)+1);
            Inc(Po,i);
        end else if (S[Po]='%') and (S[Po+1] in ['0'..'9']) and (S[Po+2] in ['0'..'9']) then begin
            if (Po2+1)>SizeOf(Code) then exit;
            if not AllowCol then exit;
            Code[Po2]:=S[Po+1];
            Code[Po2+1]:=S[Po+2];
            Inc(Po2,2);
            Dim:=(Ord(S[Po+1])-Ord('0'))*10+(Ord(S[Po+2])-Ord('0'));
            if Maxdim<Dim then Maxdim:=Dim;
            if not (Dim in NeedData) then NeedData:=NeedData+[Dim];
            Inc(Po,3);
        end else if S[Po] in ['+','-','*','/','\','^','(',')','!',','] then begin
            if Po2>SizeOf(Code) then exit;
            Code[Po2]:=S[Po];
            Inc(Po2);
            Inc(Po);
        end else begin
            Find:=False;
            i:=0;
            While (i<OperatorNum) and (not Find) do begin
                Inc(i);
                j:=1;
                While (j<=Length(OperatorTable[i].Op))
                      and (S[Po+j-1]=OperatorTable[i].Op[j]) do Inc(j);
                Find:=(j=(Length(OperatorTable[i].Op)+1));
            end;
            if not Find then begin
                 if S[Po]='X' then begin
                     if Po2>SizeOf(Code) then exit;
                     if not AllowX then exit;
                     Code[Po2]:=S[Po];
                     Inc(Po2);
                     Inc(Po);
                     if Maxdim<hax then Maxdim:=hax;
                     if not (hax in NeedData) then NeedData:=NeedData+[hax];
                     if DotTyp in [36..39] then begin
                         if Maxdim<hax+1 then Maxdim:=hax+1;
                         if not ((hax+1) in NeedData) then NeedData:=NeedData+[hax+1];
                     end else if DotTyp=41 then begin
                         if Maxdim<hax+2 then Maxdim:=hax+2;
                         if not ((hax+1) in NeedData) then NeedData:=NeedData+[hax+1];
                         if not ((hax+2) in NeedData) then NeedData:=NeedData+[hax+2];
                     end;
                 end else if S[Po]='Y' then begin
                     if Po2>SizeOf(Code) then exit;
                     if not AllowY then exit;
                     Code[Po2]:=S[Po];
                     Inc(Po2);
                     Inc(Po);
                     if Maxdim<vax then Maxdim:=vax;
                     if not (vax in NeedData) then NeedData:=NeedData+[vax];
                     if DotTyp in [36..39] then begin
                         if Maxdim<vax+1 then Maxdim:=vax+1;
                         if not ((vax+1) in NeedData) then NeedData:=NeedData+[vax+1];
                     end else if DotTyp=40 then begin
                         if Maxdim<vax+2 then Maxdim:=vax+2;
                         if not ((vax+1) in NeedData) then NeedData:=NeedData+[vax+1];
                         if not ((vax+2) in NeedData) then NeedData:=NeedData+[vax+2];
                     end;
                end else if ((Copy(S,Po,3)='MIN') or (Copy(S,Po,3)='MAX')) and (S[Po+3] in ['X','Y']) then begin
                    if Po2+2>SizeOf(Code) then exit;
                    if not AllowMemory then exit;
                    if S[Po+1]='I' then Code[Po2]:='<'
                                   else Code[Po2]:='>';
                    Code[Po2+1]:=S[Po+3];
                    Inc(Po,4);
                    Inc(Po2,2);
                    Need2Pass:=True;
                end else if (Copy(S,Po,5)='EULER') or (S[Po]='E') or (Copy(S,Po,2)='PI') then begin
                    if Po2+SizeOf(Real)>SizeOf(Code) then exit;
                    Code[Po2]:='#';
                    if (Copy(S,Po,5)='EULER') then begin
                        x:=MEuler;
                        Inc(Po,5);
                    end else if (S[Po]='E') then begin
                        x:=MExp1;
                        Inc(Po);
                    end else begin
                        x:=MPi;
                        Inc(Po,2);
                    end;
                    Move(x,Code[Po2+1],SizeOf(Real));
                    Inc(Po2,SizeOf(Real)+1);
                end else if (Copy(S,Po,3)='NAN') then begin
                    if Po2>SizeOf(Code) then exit;
                    Code[Po2]:='~';
                    Inc(Po,3);
                    Inc(Po2);
                end else if (Copy(S,Po,4)='NONE') then begin
                    if Po2>SizeOf(Code) then exit;
                    Code[Po2]:='@';
                    Inc(Po,4);
                    Inc(Po2);
                end else exit;
            end else begin
                if Po2+2>SizeOf(Code) then exit;
                if not AllowMemory and (OperatorTable[i].Cd in ['{','}','[',']']) then exit;
                if not AllowUser and (OperatorTable[i].Cd in [Chr($A0),Chr($A1)]) then exit;
                if OperatorTable[i].Cd='[' then begin
                    if IntegDataPo>=10 then exit;
                    Code[Po2]:=Chr($80+IntegDataPo);
                    Inc(IntegDataPo);
                end else if OperatorTable[i].Cd=']' then begin
                    if DefDataPo>=10 then exit;
                    Code[Po2]:=Chr($90+DefDataPo);
                    Inc(DefDataPo);
                end else Code[Po2]:=OperatorTable[i].Cd;
                Code[Po2+1]:=Chr(Ord('0')+OperatorTable[i].Arg);
                Code[Po2+2]:='(';
                Inc(Po2,3);
                Inc(Po,Length(OperatorTable[i].Op));
            end;
        end;
    end;
    if Po2>SizeOf(Code) then exit;
    Code[Po2]:='_';
    InterplitMath:=True;
end;

function Calculate(Code:MathCodeType;x,y,Minx,Miny,Maxx,Maxy:Real;XStatus,YStatus:ShortInt;
                   var MathData;var MathStatus;var Memory,IntegData,DefData;var DefFirst;
                   var Value:Real):Integer;
var NumBuf:Array[1..20] of Real;
    NumStatus:Array [1..20] of ShortInt;
    OpBuf :Array[1..20] of Char;
    PreBuf:Array[1..20] of Byte;
    ArgBuf:Array[1..20] of Byte;
    NoExpand:Array[0..20] of Boolean;
    Po,NumPo,OpPo,IfPo,i:Integer;
    Numeric:Boolean;
    a:Real;
    ArgNum:Byte;

                  procedure Expand(Pre:Byte);
                  var x:Real;
                      i:Integer;
                      Status:Integer;
                      ArgNum:Byte;
                      UMaxDim:Integer;
                      UDummy:Byte;
                      UNeedData :ByteSet;
                      UNeed2Pass:Boolean;
                      UCode:Integer;
                  begin
                      While (OpPo>0) and (Pre<=PreBuf[OpPo]) do begin
                        if OpBuf[OpPo] in ['+','-','*','/','\','^'] then ArgNum:=2
                                                                    else ArgNum:=ArgBuf[OpPo];
                        if OpBuf[OpPo]='?' then begin
                            if (NumBuf[NumPo-2]<>0) then begin
                                NumBuf[NumPo-2]:=NumBuf[NumPo-1];
                                NumStatus[NumPo-2]:=NumStatus[NumPo-1];
                            end else begin
                                NumBuf[NumPo-2]:=NumBuf[NumPo];
                                NumStatus[NumPo-2]:=NumStatus[NumPo];
                            end;
                        end else if not NoExpand[IfPo] then begin
                          Status:=0;
                          for i:=1 to ArgNum do if NumStatus[NumPo-i+1]<Status then Status:=NumStatus[NumPo-i+1];
                          if Status<>0 then NumStatus[NumPo-ArgNum+1]:=Status
                          else
                            case OpBuf[OpPo] of
                              '!': if (Frac(NumBuf[NumPo])<>0) or (NumBuf[NumPo]>167) or (NumBuf[NumPo]<0) then
                                       NumStatus[NumPo]:=-1
                                   else begin
                                       x:=1;
                                       for i:=2 to Trunc(NumBuf[NumPo]) do x:=x*i;
                                       NumBuf[NumPo]:=x;
                                   end;
                              '^': begin
                                     if (NumBuf[NumPo-1]=0) and (NumBuf[NumPo]=0) then NumBuf[NumPo-1]:=1
                                     else if (NumBuf[NumPo-1]=0) then NumBuf[NumPo-1]:=0
                                     else if Frac(NumBuf[NumPo])=0 then begin
                                         x:=NumBuf[NumPo]*Ln(Abs(NumBuf[NumPo-1]));
                                         if x>690 then NumStatus[NumPo-1]:=-1
                                         else if x<-690 then NumBuf[NumPo-1]:=0
                                         else begin
                                             if Frac(NumBuf[NumPo]/2)=0 then
                                                  NumBuf[NumPo-1]:=Exp(x)
                                             else if NumBuf[NumPo-1]>=0 then
                                                  NumBuf[NumPo-1]:=Exp(x)
                                             else NumBuf[NumPo-1]:=-Exp(x);
                                         end;
                                     end else if NumBuf[NumPo-1]<0 then NumStatus[NumPo-1]:=-1
                                     else begin
                                         x:=NumBuf[NumPo]*Ln(NumBuf[NumPo-1]);
                                         if x>690 then NumStatus[NumPo-1]:=-1
                                         else if x<-690 then NumBuf[NumPo-1]:=0
                                         else NumBuf[NumPo-1]:=Exp(x);
                                     end;
                                   end;
                              '+': NumBuf[NumPo-1]:=NumBuf[NumPo-1]+NumBuf[NumPo];
                              '&': NumBuf[NumPo]:=-NumBuf[NumPo];
                              '-': NumBuf[NumPo-1]:=NumBuf[NumPo-1]-NumBuf[NumPo];
                              '/': if (Abs(NumBuf[NumPo])<=1E-300) then NumStatus[NumPo-1]:=-1
                                   else NumBuf[NumPo-1]:=NumBuf[NumPo-1]/NumBuf[NumPo];
                              '\': if (Abs(NumBuf[NumPo])<=1E-300) then NumStatus[NumPo-1]:=-1
                                   else NumBuf[NumPo-1]:=NumBuf[NumPo-1]-Int(NumBuf[NumPo-1]/NumBuf[NumPo])*NumBuf[NumPo];
                              '*': NumBuf[NumPo-1]:=NumBuf[NumPo-1]*NumBuf[NumPo];
                              'A': NumBuf[NumPo]:=Abs(NumBuf[NumPo]);
                              'B': if NumBuf[NumPo]>=0 then NumBuf[NumPo]:=1
                                   else NumBuf[NumPo]:=-1;
                              'C': NumBuf[NumPo]:=Int(NumBuf[NumPo]);
                              'D': NumBuf[NumPo]:=Frac(NumBuf[NumPo]);
                              'E': if Abs(Frac(NumBuf[NumPo]))>=0.5 then begin
                                      if NumBuf[NumPo]>=0 then NumBuf[NumPo]:=NumBuf[NumPo]-Frac(NumBuf[NumPo])+1
                                                          else NumBuf[NumPo]:=NumBuf[NumPo]-Frac(NumBuf[NumPo])-1;
                                   end else NumBuf[NumPo]:=NumBuf[NumPo]-Frac(NumBuf[NumPo]);
                              'F': if Abs(NumBuf[NumPo])>1E150 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=Sqr(NumBuf[NumPo]);
                              'G': if NumBuf[NumPo]<0 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=Sqrt(NumBuf[NumPo]);
                              'H': if NumBuf[NumPo]>690 then NumStatus[NumPo]:=-1
                                   else if NumBuf[NumPo]<-690 then NumBuf[NumPo]:=0
                                   else NumBuf[NumPo]:=Exp(NumBuf[NumPo]);
                              'I': if NumBuf[NumPo]<=0 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=Ln(NumBuf[NumPo]);
                              'J': if NumBuf[NumPo]<=0 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=Ln(NumBuf[NumPo])/Ln(10);
                              'K': NumBuf[NumPo]:=Sin(NumBuf[NumPo]);
                              'L': NumBuf[NumPo]:=Cos(NumBuf[NumPo]);
                              'M': begin
                                     x:=Cos(NumBuf[NumPo]);
                                     if Abs(x)=1E-300 then NumStatus[NumPo]:=-1
                                     else NumBuf[NumPo]:=Sin(NumBuf[NumPo])/x;
                                   end;
                              'N': if Abs(NumBuf[NumPo])>1 then NumStatus[NumPo]:=-1
                                   else if NumBuf[NumPo]=-1 then NumBuf[NumPo]:=-MPi*0.5
                                   else if NumBuf[NumPo]=1 then NumBuf[NumPo]:=MPi*0.5
                                   else NumBuf[NumPo]:=ArcTan(NumBuf[NumPo]/Sqrt(1-Sqr(NumBuf[NumPo])));
                              'O': if Abs(NumBuf[NumPo])>1 then NumStatus[NumPo]:=-1
                                   else if NumBuf[NumPo]=0 then NumBuf[NumPo]:=MPi*0.5
                                   else if NumBuf[NumPo]>0 then NumBuf[NumPo]:=ArcTan(Sqrt(1-Sqr(NumBuf[NumPo]))/NumBuf[NumPo])
                                   else if NumBuf[NumPo]<0 then NumBuf[NumPo]:=
                                       ArcTan(Sqrt(1-Sqr(NumBuf[NumPo]))/NumBuf[NumPo])+MPi;
                              'P': NumBuf[NumPo]:=ArcTan(NumBuf[NumPo]);
                              'Q': if Abs(NumBuf[NumPo])>690 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=(Exp(NumBuf[NumPo])-Exp(-NumBuf[NumPo]))*0.5;
                              'R': if Abs(NumBuf[NumPo])>690 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=(Exp(NumBuf[NumPo])+Exp(-NumBuf[NumPo]))*0.5;
                              'S': if Abs(NumBuf[NumPo])>345 then NumStatus[NumPo]:=-1
                                   else NumBuf[NumPo]:=(Exp(2*NumBuf[NumPo])-1)/(Exp(2*NumBuf[NumPo])+1);
                              'T': if Abs(NumBuf[NumPo])>1E150 then NumStatus[NumPo]:=-1
                                   else begin
                                     x:=NumBuf[NumPo]+Sqrt(Sqr(NumBuf[NumPo])+1);
                                     if x<=0 then NumStatus[NumPo]:=-1
                                     else NumBuf[NumPo]:=Ln(x);
                                   end;
                              'U': if (Abs(NumBuf[NumPo])>1E150) or (Abs(NumBuf[NumPo])<1) then NumStatus[NumPo]:=-1
                                   else begin
                                     x:=NumBuf[NumPo]+Sqrt(Sqr(NumBuf[NumPo])-1);
                                     if x<=0 then NumStatus[NumPo]:=-1
                                     else NumBuf[NumPo]:=Ln(x);
                                   end;
                              'V': if NumBuf[NumPo]=1 then NumStatus[NumPo]:=-1
                                   else begin
                                       x:=(1+NumBuf[NumPo])/(1-NumBuf[NumPo]);
                                       if x<=0 then NumStatus[NumPo]:=-1
                                       else NumBuf[NumPo]:=Ln(x)*0.5;
                                   end;
                              'W': if NumBuf[NumPo]>=0 then NumBuf[NumPo]:=1
                                   else NumBuf[NumPo]:=0;
                              'Z': if NumBuf[NumPo]=0 then NumBuf[NumPo]:=1
                                                      else NumBuf[NumPo]:=0;
                              'a': if (NumBuf[NumPo]>=0) then NumBuf[NumPo]:=Int(NumBuf[NumPo])
                                   else if Frac(NumBuf[NumPo])=0 then NumBuf[NumPo]:=Int(NumBuf[NumPo])
                                   else NumBuf[NumPo]:=Int(NumBuf[NumPo])-1;
                              'b': if not Gamma(NumBuf[NumPo],NumBuf[NumPo]) then NumStatus[NumPo]:=-1;
                              'c': if not IcGamma(NumBuf[NumPo-1],NumBuf[NumPo],NumBuf[NumPo-1]) then NumStatus[NumPo-1]:=-1;
                              'd': if not Erfc(NumBuf[NumPo],NumBuf[NumPo]) then NumStatus[NumPo]:=-1;
                              'e': if not Exp1(NumBuf[NumPo],NumBuf[NumPo]) then NumStatus[NumPo]:=-1;
                              'f': if not Beta(NumBuf[NumPo-1],NumBuf[NumPo],NumBuf[NumPo-1]) then NumStatus[NumPo-1]:=-1;
                              'g': if (Frac(NumBuf[NumPo-1])<>0) or (Abs(NumBuf[NumPo-1])>1000) then NumStatus[NumPo-1]:=-1
                                   else if not JBessel(Round(NumBuf[NumPo-1]),NumBuf[NumPo],NumBuf[NumPo-1]) then
                                       NumStatus[NumPo-1]:=-1;
                              'h': if (Frac(NumBuf[NumPo-1])<>0) or (Abs(NumBuf[NumPo-1])>1000) then NumStatus[NumPo-1]:=-1
                                   else if not YBessel(Round(NumBuf[NumPo-1]),NumBuf[NumPo],NumBuf[NumPo-1]) then
                                       NumStatus[NumPo-1]:=-1;
                              'i': if (NumBuf[NumPo-1]>NumBuf[NumPo]) then NumBuf[NumPo-1]:=NumBuf[NumPo];
                              'j': if (NumBuf[NumPo-1]<NumBuf[NumPo]) then NumBuf[NumPo-1]:=NumBuf[NumPo];
                              'k': if (NumBuf[NumPo-1]=NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                      else NumBuf[NumPo-1]:=0;
                              'l': if (NumBuf[NumPo-1]<>NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                       else NumBuf[NumPo-1]:=0;
                              'm': if (NumBuf[NumPo-1]>=NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                       else NumBuf[NumPo-1]:=0;
                              'n': if (NumBuf[NumPo-1]>NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                      else NumBuf[NumPo-1]:=0;
                              'o': if (NumBuf[NumPo-1]<=NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                       else NumBuf[NumPo-1]:=0;
                              'p': if (NumBuf[NumPo-1]<NumBuf[NumPo]) then NumBuf[NumPo-1]:=1
                                                                      else NumBuf[NumPo-1]:=0;
                              'q': if (NumBuf[NumPo]=0) then NumBuf[NumPo]:=1
                                                        else NumBuf[NumPo]:=0;
                              'r': if (NumBuf[NumPo-1]<>0) or (NumBuf[NumPo]<>0) then NumBuf[NumPo-1]:=1
                                                                                 else NumBuf[NumPo-1]:=0;
                              's': if (NumBuf[NumPo-1]<>0) and (NumBuf[NumPo]<>0) then NumBuf[NumPo-1]:=1
                                                                                  else NumBuf[NumPo-1]:=0;
                              't': if (NumBuf[NumPo-1]<>0) xor (NumBuf[NumPo]<>0) then NumBuf[NumPo-1]:=1
                                                                                  else NumBuf[NumPo-1]:=0;
                              'u': NumBuf[NumPo]:=NumBuf[NumPo]*Random;
                              'v': if (Frac(NumBuf[NumPo-1])<>0)  or (Abs(NumBuf[NumPo-1])>1000) then NumStatus[NumPo-1]:=-1
                                   else if not Legendre(Round(NumBuf[NumPo-1]),NumBuf[NumPo],NumBuf[NumPo-1]) then
                                       NumStatus[NumPo-1]:=-1;
                              'w': if (Frac(NumBuf[NumPo-2])<>0)  or (Abs(NumBuf[NumPo-2])>1000) then NumStatus[NumPo-2]:=-1
                                   else if not Laguer(Round(NumBuf[NumPo-2]),NumBuf[NumPo-1],NumBuf[NumPo],NumBuf[NumPo-2]) 
                                   then
                                       NumStatus[NumPo-2]:=-1;
                              'x': if (Frac(NumBuf[NumPo-1])<>0)  or (Abs(NumBuf[NumPo-1])>1000) then NumStatus[NumPo-1]:=-1
                                   else if not Hermite(Round(NumBuf[NumPo-1]),NumBuf[NumPo],NumBuf[NumPo-1]) then
                                       NumStatus[NumPo-1]:=-1;
                              'y': if (Frac(NumBuf[NumPo-1])<>0)  or (Abs(NumBuf[NumPo-1])>1000) then NumStatus[NumPo-1]:=-1
                                   else if not Chebyshev(Round(NumBuf[NumPo-1]),NumBuf[NumPo],NumBuf[NumPo-1]) then
                                       NumStatus[NumPo-1]:=-1;
                              '{': begin
                                     if (Frac(NumBuf[NumPo-1])<>0) or (NumBuf[NumPo-1]<0) or (NumBuf[NumPo-1]>9)
                                     then NumStatus[NumPo-1]:=-1
                                     else begin
                                         MemoryDataType(Memory)[Round(NumBuf[NumPo-1])]:=NumBuf[NumPo];
                                         NumBuf[NumPo-1]:=NumBuf[NumPo];
                                     end;
                                   end;
                              '}': begin
                                     if (Frac(NumBuf[NumPo])<>0) or (NumBuf[NumPo]<0) or (NumBuf[NumPo]>9)
                                     then NumStatus[NumPo]:=-1
                                     else NumBuf[NumPo]:=MemoryDataType(Memory)[Round(NumBuf[NumPo])];
                                   end;

                              Chr($80)..Chr($89): begin
                                     i:=Ord(OpBuf[OpPo])-$80;
                                     MemoryDataType(IntegData)[i]:=MemoryDataType(IntegData)[i]+NumBuf[NumPo];
                                     NumBuf[NumPo]:=MemoryDataType(IntegData)[i];
                                   end;
                              Chr($90)..Chr($99): begin
                                     i:=Ord(OpBuf[OpPo])-$90;
                                     if DefFirstType(DefFirst)[i] then begin
                                         MemoryDataType(DefData)[i]:=NumBuf[NumPo];
                                         DefFirstType(DefFirst)[i]:=False;
                                         NumStatus[NumPo]:=-2;
                                     end else begin
                                         a:=NumBuf[NumPo]-MemoryDataType(DefData)[i];
                                         MemoryDataType(DefData)[i]:=NumBuf[NumPo];
                                         NumBuf[NumPo]:=a;
                                     end;
                                   end;
                              Chr($A0)..Chr($A1): begin
                                     i:=Ord(OpBuf[OpPo])-$A0;
                                     if UserFnIntp[i]=0 then begin
                              	         if not InterplitMath(NGRAPH.UserFn[i],UserFnCode[i]^,UMaxdim,UNeedData,UNeed2Pass,
                                                              0,0,0,False,False,True,True,False)
                                         then begin
                                             UserFnIntp[i]:=-1;
                                             ErrorDisp('Error: Syntax in Transformation (User defined function)');
                                         end else UserFnIntp[i]:=1;
                                     end;
                                     if UserFnIntp[i]=1 then begin
                                         UCode:=Calculate(UserFnCode[i]^,NumBuf[NumPo-1],NumBuf[NumPo],0,0,0,0,
                                                NumStatus[NumPo-1],NumStatus[NumPo],
                                                UDummy,UDummy,UDummy,UDummy,UDummy,UDummy,NumBuf[NumPo-1]);
                                         if UCode=1 then begin
                                             UserFnIntp[i]:=-1;
                                             ErrorDisp('Error: Syntax in Transformation (User defined function)');
                                             NumStatus[NumPo]:=-1;
                                         end else NumStatus[NumPo-1]:=UCode;
                                     end else NumStatus[NumPo-1]:=-1;
                                   end;
                              '?': if (NumBuf[NumPo-2]<>0) then NumBuf[NumPo-2]:=NumBuf[NumPo-1]
                                                           else NumBuf[NumPo-2]:=NumBuf[NumPo];

                          end;
                        end;
                        if OpBuf[OpPo]='?' then Dec(IfPo);
                        NumPo:=NumPo-ArgNum+1;
                        Dec(OpPo);
                      end;
                  end;

                  function PushNum(x:Real;DPo:Integer;Status:ShortInt):Boolean;
                  begin
                      if NumPo>=20 then PushNum:=False
                      else begin
                          PushNum:=True;
                          Inc(NumPo);
                          NumBuf[NumPo]:=x;
                          NumStatus[NumPo]:=Status;
                          Inc(Po,DPo);
                      end;
                  end;

                  function PushOp(Pre,DPo:Integer;Arg:Byte):Boolean;
                  begin
                      if OpPo>=20 then PushOp:=False
                      else begin
                          PushOp:=True;
                          Inc(OpPo);
                          OpBuf[OpPo]:=Code[Po];
                          ArgBuf[OpPo]:=Arg;
                          PreBuf[OpPo]:=Pre;
                          Inc(Po,DPo);
                      end;
                  end;

begin
    Po:=0;
    NumPo:=0;
    OpPo:=0;
    IfPo:=0;
    NoExpand[0]:=False;
    Calculate:=1;
    Numeric:=False;
    While (Code[Po]<>'_') do begin
        if (Code[Po]='-') and not Numeric then Code[Po]:='&';
        case Code[Po] of
               '#': begin
                      if Numeric then exit;
                      if not PushNum(Real((@Code[Po+1])^),SizeOf(Real)+1,0) then exit;
                      Numeric:=True;
                    end;
               '~': begin
                      if Numeric then exit;
                      if not PushNum(0,1,-2) then exit;
                      Numeric:=True;
                    end;
               '@': begin
                      if Numeric then exit;
                      if not PushNum(0,1,-3) then exit;
                      Numeric:=True;
                    end;
               'X': begin
                      if Numeric then exit;
                      if not PushNum(x,1,XStatus) then exit;
                      Numeric:=True;
                    end;
               'Y': begin
                      if Numeric then exit;
                      if not PushNum(y,1,YStatus) then exit;
                      Numeric:=True;
                    end;
          '0'..'9': begin
                      if Numeric then exit;
                      i:=(Ord(Code[Po])-Ord('0'))*10+Ord(Code[Po+1])-Ord('0');
                      if not PushNum(MathDataType(MathData)[i],2,MathStatusType(MathStatus)[i]) then exit;
                      Numeric:=True;
                    end;
               '<': begin
                      if Numeric then exit;
                      if Code[Po+1]='X' then begin
                          if not PushNum(MinX,2,0) then exit;
                      end else begin
                          if not PushNum(MinY,2,0) then exit;
                      end;
                      Numeric:=True;
                    end;
               '>': begin
                      if Numeric then exit;
                      if Code[Po+1]='X' then begin
                          if not PushNum(MaxX,2,0) then exit;
                      end else begin
                          if not PushNum(MaxY,2,0) then exit;
                      end;
                      Numeric:=True;
                    end;
               '&': begin
                      if Numeric then exit;
                      if not PushOp(5,1,1) then exit;
                    end;
            'A'..'W','Z','a'..'y','{','}',Chr($80)..Chr($89),Chr($90)..Chr($99),Chr($A0)..Chr($A1),'?':
                    begin
                      if Numeric then exit;
                      if not PushOp(5,2,Ord(Code[Po+1])-Ord('0')) then exit;
                    end;
               '!': begin
                      if not Numeric then exit;
                      Expand(5);
                      if not PushOp(5,1,1) then exit;
                      Numeric:=True;
                    end;
               '^': begin
                      if not Numeric then exit;
                      Expand(4);
                      if not PushOp(4,1,1) then exit;
                      Numeric:=False;
                    end;
       '*','/','\': begin
                      if not Numeric then exit;
                      Expand(3);
                      if not PushOp(3,1,1) then exit;
                      Numeric:=False;
                    end;
           '+','-': begin
                      if not Numeric then exit;
                      Expand(2);
                      if not PushOp(2,1,1) then exit;
                      Numeric:=False;
                    end;
               ')': begin
                      if not Numeric then exit;
                      Expand(1);
                      if OpPo=0 then exit;
                      if ArgBuf[OpPo]<>1 then exit;
                      While OpBuf[OpPo]=',' do Dec(OpPo);
                      if OpBuf[OpPo]='(' then Dec(OpPo);
                      Inc(Po);
                      Numeric:=True;
                    end;
               ',': begin
                      if not Numeric then exit;
                      Expand(1);
                      if OpPo=0 then exit;
                      if ArgBuf[OpPo]<1 then exit;
                      if (OpPo>1) and (OpBuf[OpPo]='(') and (OpBuf[OpPo-1]='?') then begin
                          Inc(IfPo);
                          if IfPo>20 then exit;
                          if (NumPo>0) and (NumStatus[NumPo]=0) and (NumBuf[NumPo]<>0) and (not NoExpand[IfPo-1]) then
                              NoExpand[IfPo]:=False
                          else NoExpand[IfPo]:=True;
                      end;
                      if (OpPo>2) and (OpBuf[OpPo]=',') and (OpBuf[OpPo-1]='(') and (OpBuf[OpPo-2]='?') then begin
                          if (NumPo>1) and (NumStatus[NumPo-1]=0) and (NumBuf[NumPo-1]=0) and (not NoExpand[IfPo-1]) then
                              NoExpand[IfPo]:=False
                          else NoExpand[IfPo]:=True;
                      end;
                      if not PushOp(0,1,ArgBuf[OpPo]-1) then exit;
                      Numeric:=False;
                    end;
               '=': begin
                      if not Numeric then exit;
                      Expand(1);
                      if OpPo>0 then exit;
                      if NumPo<>1 then exit;
                      Inc(Po);
                      Value:=NumBuf[1];
                      NumPo:=0;
                      Numeric:=False;
                    end;
               '(': begin
                      if Numeric then exit;
                      if OpPo=0 then ArgNum:=1
                      else ArgNum:=ArgBuf[OpPo];
                      if not PushOp(0,1,ArgNum) then exit;
                    end;
               else exit;
        end;
    end;
    Calculate:=NumStatus[1];
end;

function OpenData(fil:Integer):Boolean;

    function FileOpen:Boolean;
    begin
        if (FilePar.Body[fil].Name<>'') and Find(FilePar.Body[fil].Name,True) then begin
           Assign(FPdata,FilePar.Body[fil].Name);
           Reset(FPdata);
           if IOErrorCheck then begin
              Close(FPData);
              FileOpen:=IOErrorCheck;
              FileOpen:=False;
           end else FileOpen:=True;
        end else FileOpen:=False;
    end;

    procedure OpenInit;
    var i,j:Integer;
    begin
      NewRead:=True;
      EndOfData:=False;
      FirstData:=True;
      ComRead:=False;
      AxisRawMode:=False;
      DataRawMode:=False;
      DataNum:=0;
      DataPo:=0;
      DataPo2:=0;
      LineNum:=0;
      for i:=0 to 9 do
          for j:=1 to 4 do begin
              MMemory^[j][i]:=0;
              IntegData^[j][i]:=0;
              DefFirst^[j][i]:=True;
          end;
      MathData^[0]:=0;
      MathError:=False;
      LogError:=False;
      for i:=0 to 1 do UserFnIntp[i]:=0;
      MaxDim:=0;
      NeedData:=[];
      if FilePar.Body[fil].Smoothingx>FilePar.Body[fil].Smoothingy then
          Smooth:=FilePar.Body[fil].Smoothingx
      else
          Smooth:=FilePar.Body[fil].Smoothingy;
    end;

var Need2Pass1,Need2Pass2,Error,Error1,Error2:Boolean;
    SMaxDim:Integer;
    SNeedData:ByteSet;
begin
With FilePar.Body[fil] do begin
    if DGSYS.Maximdata=0 then begin
       Error:=True;
       ErrorDisp('Error: No Data buffer');
    end else Error:= not FileOpen;
    if not Error then begin
       OpenData:=True;
       DataFile:=fil;
       OpenInit;
       if not InterplitMath(ModX,MathCodeX^,Maxdim,NeedData,Need2Pass1,DotTyp,hax,vax,True,True,True,True,True)
         then Error1:=True
         else Error1:=False;
       if not InterplitMath(ModY,MathCodeY^,Maxdim,NeedData,Need2Pass2,DotTyp,hax,vax,True,True,True,True,True)
         then Error2:=True
         else Error2:=False;
       if Error1 or Error2 then begin
           ErrorDisp('Error: Syntax in Transformation');
           Error:=True;
           CloseData;
       end else if Need2Pass1 or Need2Pass2 then begin
           AxisRawMode:=True;
           DataRawMode:=True;
           SMaxDim:=MaxDim;
           SNeedData:=NeedData;
           if hax>vax then MaxDim:=hax
                      else MaxDim:=vax;
           NeedData:=[hax,vax];
           NMinx:=0;
           NMiny:=0;
           NMaxx:=0;
           NMaxy:=0;
           GetMinMax2(NMinx,NMiny,NMaxx,NMaxy);
           CloseData;
           Error:=not FileOpen;
           OpenInit;
           MaxDim:=SMaxDim;
           NeedData:=SNeedData;
       end;
    end;
    if Error then begin
       OpenData:=False;
       DataFile:=fil;
       DataNum:=-2;
       EndOfData:=True;
    end;
end;
end;

function UseData(Num:Integer):Boolean;
begin
    if DGSYS.Maximdata=0 then begin
        ErrorDisp('Error: No Data buffer');
        UseData:=False;
     end else UseData:=True;
     DataFile:=0;
     EndOfData:=True;
     NewRead:=False;
     AxisRawMode:=True;
     DataRawMode:=True;
     DataPo:=0;
     DataPoMax:=Num-1;
     FirstData:=True;
     Smooth:=0;
     DataNum:=Num;
end;

procedure CloseData;
var Error:Boolean;
begin
   if not EndOfData then begin
       Error:=IOErrorCheck;
       Close(FPdata);
       Error:=IOErrorCheck;
   end;
   EndOfData:=True;
   if DataFile<>0 then begin
       FilePar.Body[DataFile].IsRead:=True;
       FilePar.Body[DataFile].DotNum:=DataNum;
   end;
end;

function Get5Line(fil:Integer;var Com:ComType):Boolean;
var Error,Er:Boolean;
    i,j:Integer;
    Ch:Char;
begin
  With FilePar.Body[Fil] do begin
     Error:=False;
     if Find(Name,True) then begin
        Assign(FPdata,Name);
        Reset(FPdata);
        Error:=IOErrorCheck;
        if Error then begin
          Close(FPData);
          Er:=IOErrorCheck;
        end else begin
            for i:=1 to 5 do
              if EOF(FPdata) then Com[i]:='[EOF]'
              else begin
                j:=1;
                Repeat
                  Read(FPdata,Ch);
                  Error:=IOErrorCheck;
                  if not Error and not (Ch in [Chr($0D),Chr($0A),Chr($1A)]) and (j<SizeOf(Com[i])) then begin
                    Com[i][j]:=Ch;
                    Inc(j);
                  end;
                until (Ch in [Chr($0A),Chr($1A)]) or EOF(FPdata) or Error;
                Com[i][0]:=Chr(j-1);
              end;
            Comment:=Com[1];
            Close(FPdata);
            Er:=IOErrorCheck;
        end;
     end;
     Get5Line:=not Error;
  end;
end;

procedure CommentSkip;
var i,j:Integer;
   Str:String;
   Error:Boolean;
   Ch:Char;
begin
  With FilePar.Body[DataFile] do begin
     for i:=1 to SkipNum do begin
         ComRead:=True;
         if not EOF(FPdata) then begin
           j:=1;
           Repeat
             Read(FPdata,Ch);
             Error:=IOErrorCheck;
             if not Error and not (Ch in [Chr($0D),Chr($0A),Chr($1A)]) and (j<SizeOf(Str)) and (i=1) then begin
               Str[j]:=Ch;
               Inc(j);
             end;
           until (Ch in [Chr($0A),Chr($1A)]) or EOF(FPdata) or Error;
           if i=1 then begin
             Str[0]:=Chr(j-1);
             Comment:=Str;
           end;
           Inc(LineNum);
         end else if i=1 then Comment:='[EOF]';
     end;
     Error:=IOErrorCheck;
  end;
end;


function GetData(var x,y:Real;var LinePos:LongInt;var NAN:Boolean):Boolean;

    function ReadData(var DataPo:Integer;DataPoMax:Integer):Integer;

          procedure ReadDataEnd(ReturnCode:Integer);
          var Error:Boolean;
          begin
               Error:=IOErrorCheck;
               Close(FPdata);
               EndOfData:=True;
               Error:=IOErrorCheck;
               ReadData:=ReturnCode;
          end;

    var N,RCode:Integer;
        ds,de,i,Flag,Dim:Integer;
        S,valline :String;
        Dat,x1,x2,y1,y2 :Real;
        sx1,sx2,sy1,sy2:ShortInt;
        Ch:Char;
        Error,Spc,Masked,Changed,Found :Boolean;
        ErrCode: array [0..3] of Integer;
        D,ReadError:Boolean;
        MathStatus:MathStatusType;

    begin
      With FilePar.Body[DataFile] do begin
           ReadData:=0;
           N:=0;
           While (DataPo<=DataPoMax) do begin
               Error:=False;
               Found:=False;
               if not ComRead and EOF(FPdata) then begin
                   Comment:='[EOF]';
                   ComRead:=True;
               end;
               While not Error and not EOF(FPdata) and not Found and ((FinalLine=-1) or (LineNum<FinalLine)) do begin
                  i:=1;
                  Repeat
                      Read(FPdata,Ch);
                      Error:=IOErrorCheck;
                      if not Error and not (Ch in [Chr($0D),Chr($0A),Chr($1A)]) and (i<SizeOf(FileLineType)) then begin
                          FileLine^[i]:=Ch;
                          Inc(i);
                      end;
                  until (Ch in [Chr($0A),Chr($1A)]) or EOF(FPdata) or Error;
                  if not Error then begin
                    FileLine^[i]:=Chr(0);
                    Inc(LineNum);
                    if not ComRead then begin
                        i:=1;
                        While (FileLine^[i]<>Chr(0)) and (i<SizeOf(Comment)) do begin
                            Comment[i]:=FileLine^[i];
                            Inc(i);
                        end;
                        Comment[0]:=Chr(i-1);
                        ComRead:=True;
                    end;
                    Masked:=False;
                    i:=1;
                    While (i<=Mask.Num) and not Masked do begin
                        if (Mask.Body[i].Fil=DataFile) and (Mask.Body[i].Lin=LineNum) then Masked:=True;
                        Inc(i);
                    end;
                    Spc:=True;
                    i:=1;
                    While FileLine^[i]<>Chr(0) do begin
                        if not (FileLine^[i] in [' ',Chr(9)]) then Spc:=False;
                        Inc(i);
                    end;
                    if not (FileLine^[1] in [Chr(0),'%',Chr($27),'#']) and not Spc and not Masked then begin
                        Found:=True;
                        LPos^[DataPo]:=LineNum;
                        de:=1;
                        Dim:=0;
                        while (Dim<MaxDim) do begin
                           Inc(Dim);
                           ds:=de;
                           While (FileLine^[ds] in [' ',Chr(9),',','(',')','"']) do Inc(ds);
                           de:=ds;
                           while not (FileLine^[de] in [Chr(0),' ',Chr(9),',','(',')','"']) do Inc(de);
                           if de-ds>=SizeOf(valline) then de:=ds+SizeOf(valline)-1;
                           for i:=ds to de-1 do valline[i-ds+1]:=FileLine^[i];
                           valline[0]:=Chr(de-ds);
                           for i:=1 to Length(valline) do
                               if valline[i]='D' then valline[i]:='E';
                           if valline[1]='.' then valline:='0'+valline
                           else if (Length(valline)>=2) and (valline[1] in ['+','-']) and (valline[2]='.') then
                               Insert('0',valline,2);
                           if valline[Length(valline)]='.' then valline:=valline+'0';
                           if Dim in NeedData then begin
                               if valline='|' then MathStatus[Dim]:=-2
                               else if valline='=' then MathStatus[Dim]:=-3
                               else begin
                                   Val(valline,Dat,Flag);
                                   if Flag<>0 then MathStatus[Dim]:=-4
                                   else begin
                                       MathData^[Dim]:=Dat;
                                       MathStatus[Dim]:=0;
                                   end;
                               end;
                           end;
                        end;
                    end;
                    for i:=2 to ReadStep do begin
                      if not Error and not EOF(FPdata) then begin
                        Repeat
                          Read(FPdata,Ch);
                          Error:=IOErrorCheck;
                        until (Ch in [Chr($0A),Chr($1A)]) or EOF(FPdata) or Error;
                        Inc(LineNum);
                      end;
                    end;
                 end;
               end;

               if not Found then begin
                   ReadDataEnd(N);
                   Exit;
               end;

               Masked:=False;
               if not Error then begin
                   MathData^[0]:=MathData^[0]+1;
                   MathStatus[0]:=0;
                   if not (DotTyp in [36..41]) then begin
                       if DataRawMode then begin
                           gx^[DataPo]:=MathData^[hax];
                           gy^[DataPo]:=MathData^[vax];
                       end else begin
                           ErrCode[0]:=Calculate(MathCodeX^,MathData^[hax],MathData^[vax],NMinx,NMiny,NMaxx,Nmaxy,
                                      MathStatus[hax],MathStatus[vax],
                                      MathData^,MathStatus,MMemory^[1],IntegData^[1],DefData^[1],DefFirst^[1],gx^[DataPo]);
                           ErrCode[1]:=Calculate(MathCodeY^,MathData^[hax],MathData^[vax],NMinx,NMiny,NMaxx,Nmaxy,
                                      MathStatus[hax],MathStatus[vax],
                                      MathData^,MathStatus,MMemory^[2],IntegData^[2],DefData^[2],DefFirst^[2],gy^[DataPo]);
                           Changed:=False;
                           i:=1;
                           While (i<=ChgData.Num) and not Changed do begin
                            if (ChgData.Body[i].Fil=DataFile) and (ChgData.Body[i].Lin=LPos^[DataPo]) then Changed:=True
                            else Inc(i);
                           end;
                           if Changed then begin
                             gx^[DataPo]:=ChgData.Body[i].x;
                             gy^[DataPo]:=ChgData.Body[i].y;
                             ErrCode[0]:=0;
                             ErrCode[1]:=0;
                           end;
                       end;
                       gx2^[DataPo]:=gx^[DataPo];
                       gy2^[DataPo]:=gy^[DataPo];
                       ErrCode[2]:=0;
                       ErrCode[3]:=0;
                   end else begin
                       if DotTyp in [36..39] then begin
                           x1:=MathData^[hax];
                           y1:=MathData^[hax+1];
                           x2:=MathData^[vax];
                           y2:=MathData^[vax+1];
                           sx1:=MathStatus[hax];
                           sy1:=MathStatus[hax+1];
                           sx2:=MathStatus[vax];
                           sy2:=MathStatus[vax+1];
                       end else if DotTyp=40 then begin
                           x1:=MathData^[hax];
                           y1:=MathData^[vax]+MathData^[vax+1];
                           x2:=MathData^[hax];
                           y2:=MathData^[vax]+MathData^[vax+2];
                           sx1:=MathStatus[hax];
                           if MathStatus[vax]<MathStatus[vax+1] then sy1:=MathStatus[vax]
                                                                else sy1:=MathStatus[vax+1];
                           sx2:=MathStatus[hax];
                           if MathStatus[vax]<MathStatus[vax+2] then sy2:=MathStatus[vax]
                                                                else sy2:=MathStatus[vax+2];
                       end else if DotTyp=41 then begin
                           x1:=MathData^[hax]+MathData^[hax+1];
                           y1:=MathData^[vax];
                           x2:=MathData^[hax]+MathData^[hax+2];
                           y2:=MathData^[vax];
                           if MathStatus[hax]<MathStatus[hax+1] then sx1:=MathStatus[vax]
                                                                else sx1:=MathStatus[vax+1];
                           sy1:=MathStatus[vax];
                           if MathStatus[hax]<MathStatus[hax+2] then sx2:=MathStatus[hax]
                                                                else sx2:=MathStatus[hax+2];
                           sy2:=MathStatus[vax];
                       end;
                       if DataRawMode then begin
                           gx^[DataPo]:=x1;
                           gy^[DataPo]:=y1;
                           gx2^[DataPo]:=x2;
                           gy2^[DataPo]:=y2;
                       end else begin
                           ErrCode[0]:=Calculate(MathCodeX^,x1,y1,NMinx,NMiny,NMaxx,Nmaxy,
                                       sx1,sy1,
                                       MathData^,MathStatus,MMemory^[1],IntegData^[1],DefData^[1],DefFirst^[1],gx^[DataPo]);
                           ErrCode[1]:=Calculate(MathCodeY^,x1,y1,NMinx,NMiny,NMaxx,Nmaxy,
                                       sx1,sy1,
                                       MathData^,MathStatus,MMemory^[2],IntegData^[2],DefData^[2],DefFirst^[2],gy^[DataPo]);
                           ErrCode[2]:=Calculate(MathCodeX^,x2,y2,NMinx,NMiny,NMaxx,Nmaxy,
                                       sx2,sy2,
                                       MathData^,MathStatus,MMemory^[3],IntegData^[3],DefData^[3],DefFirst^[3],gx2^[DataPo]);
                           ErrCode[3]:=Calculate(MathCodeY^,x2,y2,NMinx,NMiny,NMaxx,Nmaxy,
                                       sx2,sy2,
                                       MathData^,MathStatus,MMemory^[4],IntegData^[4],DefData^[4],DefFirst^[4],gy2^[DataPo]);
                       end;
                   end;
                   if not DataRawMode then begin
                       ReadError:=False;
                       Str(LineNum,S);
                       for i:=0 to 3 do begin
                           if ErrCode[i]=1 then begin
                               ErrorDisp('Error: Syntax in Transformation');
                               ReadDataEnd(-1);
                               Exit;
                           end else if ErrCode[i]=-1 then begin
                               Error:=True;
                               if not MathError then begin
                                   ErrorDisp('Warning: Math Error in Transformation');
                                   MathError:=True;
                               end;
                           end else if ErrCode[i]=-2 then Masked:=True
                           else if ErrCode[i]=-3 then Error:=True
                           else if ErrCode[i]=-4 then begin
                              if not ReadError then begin
                                ReadError:=True;
                                Beep;
                                D:=DisplayGraph;
                                if D then StopGraph;
                                Ch:=InputYN(1,THeight,'Error: Read Data/'
                                   +MakeFileName2(Name)+'('+S+'). Continue? (Y/N)');
                                if D then StartGraph;
                                if not (Ch in ['Y','y']) then begin
                                  ReadDataEnd(-1);
                                  Exit;
                                end;
                              end;
                              Error:=True;
                           end;
                       end;
                       if not Error and not Masked then begin
                           if not (CheckData(AxisPar[Axisx*2].ScType,gx^[DataPo])
                               and CheckData(AxisPar[Axisx*2].ScType,gx2^[DataPo])
                               and CheckData(AxisPar[Axisy*2+1].ScType,gy^[DataPo])
                               and CheckData(AxisPar[Axisy*2+1].ScType,gy2^[DataPo])) then begin
                               Error:=True;
                               if not LogError then begin
                                   Errordisp('Warning: Negative Data found in Log');
                                   LogError:=True;
                               end;
                           end else begin
                               i:=1;
                               While (i<=MaskReg.Num) and not Masked do With MaskReg.Body[i] do begin
                                   if (MaskReg.Body[i].Fil=DataFile)
                                      and (Mx1<gx^[DataPo]) and (gx^[DataPo]<Mx2)
                                      and (My1<gy^[DataPo]) and (gy^[DataPo]<My2)
                                      and (Mx1<gx2^[DataPo]) and (gx2^[DataPo]<Mx2)
                                      and (My1<gy2^[DataPo]) and (gy2^[DataPo]<My2) then Masked:=True;
                                   Inc(i);
                               end;
                           end;
                       end;
                   end;
               end;
               if Error then begin
                   gStat^[DataPo]:=-1;
                   Inc(DataPo);
               end else if not Masked then begin
                   gStat^[DataPo]:=0;
                   Inc(DataPo);
                   Inc(N);
               end;

           end;
           ReadData:=N;
      end;
    end;

    procedure Average(var x1,y1:Real;var x2,y2:GraphDataType;var stat:gStatType);
    var Num,i,st,ed:Integer;
        Sum:Real;
    begin
      With FilePar.Body[DataFile] do begin
          if (Smoothingx=0) or (DataRawMode) then x1:=x2[DataPo]
          else begin
              st:=DataPo-Smoothingx;
              if st<0 then st:=0;
              ed:=DataPo+Smoothingx;
              if ed>DataPoMax then ed:=DataPoMax;
              Sum:=0;
              Num:=0;
              for i:=st to ed do if stat[i]=0 then begin
                  Sum:=Sum+x2[i];
                  Inc(Num);
              end;
              x1:=Sum/Num;
          end;
          if (Smoothingy=0) or (DataRawMode) then y1:=y2[DataPo]
          else begin
              st:=DataPo-Smoothingy;
              if st<0 then st:=0;
              ed:=DataPo+Smoothingy;
              if ed>DataPoMax then ed:=DataPoMax;
              Sum:=0;
              Num:=0;
              for i:=st to ed do if stat[i]=0 then begin
                  Sum:=Sum+y2[i];
                  Inc(Num);
              end;
              y1:=Sum/Num;
          end;
      end;
    end;

    function NeedData:Boolean;
    var i,st:Integer;
    begin
        if (DataPo+Smooth>DataPoMax) and not EndOfData then begin
            st:=DataPo-Smooth;
            if st<0 then st:=0;
            for i:=st to DataPoMax do begin
                gx^[i-st]:=gx^[i];
                gy^[i-st]:=gy^[i];
                gx2^[i-st]:=gx2^[i];
                gy2^[i-st]:=gy2^[i];
                gStat^[i-st]:=gStat^[i];
            end;
            Dec(DataPo,st);
            DataPo2:=DataPoMax-st+1;
            NeedData:=True;
        end else NeedData:=False;
    end;

var N:Integer;
    Error:Boolean;
begin
   if not ComRead and not EndOfData then CommentSkip;
   if NewRead and not EndOfData then begin
       N:=ReadData(DataPo2,DGSYS.Maximdata-1);
       NewRead:=False;
       DataPoMax:=DataPo2-1;
       if N<0 then begin
	    DataNum:=-1;
	    GetData:=False;
	    Exit;
       end else Inc(DataNum,N);
   end;
   if (NewRead and EndOfData) or (DataPo>DataPoMax) then begin
	GetData:=False;
	Exit;
   end;
   if FirstData then begin
        LinePos:=LPos^[DataPo];
        if gStat^[DataPo]<>0 then NAN:=True
        else begin
            NAN:=False;
            Average(x,y,gx^,gy^,gStat^);
        end;
        if FilePar.Body[DataFile].DotTyp in [36..41] then FirstData:=False
	else Inc(DataPo);
   end else begin
        LinePos:=LPos^[DataPo];
        if gStat^[DataPo]<>0 then NAN:=True
        else begin
            NAN:=False;
            Average(x,y,gx2^,gy2^,gStat^);
        end;
	FirstData:=True;
	Inc(DataPo);
   end;
   NewRead:=NeedData;
   if (not AxisRawMode) and (not DataRawMode) and not NAN then begin
       Error:=ConvData(True,AxisPar[FilePar.Body[DataFile].Axisx*2].ScType,x);
       Error:=ConvData(True,AxisPar[FilePar.Body[DataFile].Axisy*2+1].ScType,y);
   end;
   GetData:=True;
end;

end.