(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* XP|֘A葱 *)

unit DataScal;

interface

uses Math,Variable;

Type Real=Double;

function  Scale(x:real):real;
function  Mainmin(min,sc:real):real;
procedure ConvScale(Change:Boolean;ScType:Integer;var min,max,sc:Real);
function  ConvData(Change:Boolean;ScType:Integer;var Dat:Real):Boolean;
function  CheckData(ScType:Integer;Dat:Real):Boolean;
procedure CheckMinMax(ScType:Integer;var min,max:Real;SetMin,SetMax:Boolean);
procedure CheckScale(ScType:Integer;min,max:Real;Var sc:Real;SetScale:Boolean);
procedure SetAutoMinMax(ScType:Integer;ming,maxg:Real;var Minim,Maxim:Real;SetMin,SetMax:Boolean;Room:Char);
procedure SetAutoScale(ScType:Integer;min,max:Real;var Incrim:Real;SetIncrim:Boolean);

implementation

function Scale(x:real):Real;
begin
    Scale:=exp(ln(10)*cutdown(log(x)));
end;

function Mainmin(min,sc:real):real;
begin
    Mainmin:=raise2(min/sc)*sc
end;

procedure ConvScale(Change:Boolean;ScType:Integer;var Min,Max,Sc:Real);
var Error:Boolean;
begin
    if not Change then begin
       Error:=ConvData(False,ScType,Min);
       Error:=ConvData(False,ScType,Max);
       Error:=ConvData(False,ScType,Sc);
    end else begin
       Error:=ConvData(True,ScType,Min);
       Error:=ConvData(True,ScType,Max);
       Error:=ConvData(True,ScType,Sc);
    end;
end;

function ConvData(Change:Boolean;ScType:Integer;var Dat:Real):Boolean;
begin
    ConvData:=True;
    if not Change then begin
       if ScType=1 then Dat:=Pow10(Dat)
    end else begin
       if ScType=1 then begin
           if Dat<=0 then begin
               Dat:=0;
               ConvData:=False;
           end else Dat:=Log(Dat);
       end;
    end;
end;

function  CheckData(ScType:Integer;Dat:Real):Boolean;
begin
    if (ScType=1) and (Dat<=0) then CheckData:=False
                               else CheckData:=True;
end;

procedure CheckMinMax(ScType:Integer;var min,max:Real;SetMin,SetMax:Boolean);
begin
    if SetMin and SetMax and (min=max) then max:=min+1;
end;

procedure CheckScale(ScType:Integer;min,max:Real;Var sc:Real;SetScale:Boolean);
begin
    if SetScale then begin
        if (ScType<>1) and (sc=0) then sc:=1;
        if ScType=1 then sc:=Round(sc);
        sc:=abs(sc);
    end;
end;

procedure SetAutoMinMax(ScType:Integer;ming,maxg:Real;var Minim,Maxim:Real;SetMin,SetMax:Boolean;Room:Char);
var min,max,sc:Real;
    Order:Real;
begin
   Order:=(Abs(maxg)+Abs(ming))*0.5;
   if (Order=0) then begin
       maxg:=1;
       ming:=-1;
   end else if Abs(maxg-ming)/Order<1E-6 then begin
       maxg:=maxg+Order*0.5;
       ming:=ming-Order*0.5;
   end;
   sc:=scale(maxg-ming);
   if maxg<ming then sc:=sc*-1;
   if Room='Y' then begin
      if sc>0 then begin
	  max:=maxg+(maxg-ming)*0.05;
	  max:=raise2(max/sc*10)*sc/10;
	  min:=ming-(maxg-ming)*0.05;
	  min:=cutdown(min/sc*10)*sc/10;
          if ScType=1 then begin
              max:=Pow10(max);
              min:=Pow10(min);
              max:=Log( raise2(max/scale(max))*scale(max) );
              min:=Log( cutdown( min/scale(min) )*scale(min) );
          end;
      end else begin
	  max:=maxg-(maxg-ming)*0.1;
	  max:=cutdown(max/sc*10)*sc/10;
	  min:=ming+(maxg-ming)*0.1;
	  min:=raise2(min/sc*10)*sc/10;
          if ScType=1 then begin
              max:=Pow10(max);
              min:=Pow10(min);
              max:=Log( cutdown( max/scale(max) )*scale(max) );
              min:=Log( raise2( min/scale(min) )*scale(min) );
          end;
      end;
   end else begin
	 max:=maxg;
	 min:=ming;
   end;
   if not SetMin then Minim:=min;
   if not SetMax then Maxim:=max;
   CheckMinMax(ScType,Minim,Maxim,True,True);
end;

procedure SetAutoScale(ScType:Integer;min,max:Real;var Incrim:Real;SetIncrim:Boolean);
var sc,Mmin:Real;
begin
   CheckMinMax(ScType,min,max,True,True);
   if (ScType<>2) or (min*max<=0) then begin
       sc:=scale(max-min);
       if max<min then sc:=sc*-1;
       Mmin:=MainMin(min,sc)+sc;
       if ((Mmin-min)*(Mmin-max)>0) then sc:=sc/10;
       if not SetIncrim then Incrim:=sc;
   end else begin
       sc:=scale(1/max-1/min);
       if 1/max<1/min then sc:=sc*-1;
       Mmin:=MainMin(1/min,sc)+sc;
       if ((Mmin-1/min)*(Mmin-1/max)>0) then sc:=sc/10;
       if not SetIncrim then Incrim:=1/sc;
   end;
   CheckScale(ScType,Min,Max,Incrim,True);
end;

end.
