(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* GRAR}h쐬OtBbN葱 *)

unit GRAGraph;

interface

uses DosCall,Gra2Crt,Clip,Time,Jctype,Variable,IOProc,Display,SysUtils;

Type Real=Double;
     wPointType = record x,y:Real; end;
     Po = array [1..6] of wPointType;

procedure nGetGraphPosition(var x1,y1,x2,y2,Sizex,Sizey:Integer);
procedure nOpenGraph;
procedure nCloseGraph;
procedure nDraw;
procedure nRemark(Str:String);
procedure nSetWriteMode(Mode:Integer);
procedure nPutImage(x,y:Integer;Color:Word);
procedure nSetViewPort;
procedure nReSetViewPort;
procedure nSetWindow(minx,miny,maxx,maxy:Real);
procedure nSetWindowAll;
procedure nSetWindowFull;
procedure nSetLineStyle(Typ,Width,Col,Cap:Integer);
procedure nSetFillColor(Col:Integer);
procedure nLine(x0,y0,x1,y1:Real);
procedure nMarkLine(x0,y0,x1,y1:Real);
procedure nPutPixel(x,y:Real);
procedure nCircle(x,y,r:Real;Fill:Boolean);
procedure nRectAngle(x0,y0,x1,y1:Real;Fill:Boolean);
procedure nSquare(x0,y0,x1,y1:Real;Fill:Boolean);
procedure nDrawPoly(NumPoints:Integer;var PolyPoints:Po;Fill:Boolean);
procedure nLineTo(x1,y1:Real);
procedure nMoveTo(x1,y1:Real);
procedure nLine2(x0,y0,x1,y1:Integer);
procedure nRectAngle2(x0,y0,x1,y1:Integer;Fill:Boolean);
procedure nMoveTo2(x1,y1:Integer);
procedure nMoveRel2(x,y:Integer);
procedure nResetTextStyle;
function  nGetTextStyle(Str:String;var Font,JFont,Size,Space,Typ,Col:Integer):Integer;
function  nGetTextCode(Font,JFont,Size,Space,Typ,Col:Integer):Str20;
procedure nTextSize(var H,W:Integer;Str:String;Init,Script:Str20;Fst:Integer);
procedure nOutString(Str:String;Init,Script:Str20;Dir:Integer;Clear:Boolean;Fst:Integer);

implementation

Var  
     TextFont,TextSize100,TextDir,TextType,TextSpace100,TextCol:Integer;
     ScriptMove:Integer;

procedure nGetGraphPosition(var x1,y1,x2,y2,Sizex,Sizey:Integer);
begin
   x1:=Mm2dot(NGRAPH.ViewX1);
   y1:=Mm2dot(NGRAPH.ViewY1);
   Sizex:=Mm2dot(NGRAPH.Sizex);
   Sizey:=Mm2dot(NGRAPH.Sizey);
   x2:=x1+Sizex;
   y2:=y1+Sizey;
end;

procedure GraphicOut;
var Error:Boolean;
    i:Integer;
    S:String;
begin
  if CCod='I' then begin
       Assign(DGSYS.GraphicFp,DGSYS.GraphicFil);
       ReWrite(DGSYS.GraphicFp);
       WriteLn(DGSYS.GraphicFp,DGSYS.Main+DGSYS.GRAtitle);
       WriteLn(DGSYS.GraphicFp,'Creator:',DGSYS.Main+DGSYS.ver);
  end;
  Write(DGSYS.GraphicFp,CCod,',',CPar[1],',');
  if CPar[1]=-1 then begin
    for i:=1 to Length(CStr) do
      if CStr[i]=Chr($0D) then Write(DGSYS.GraphicFp,'\n')
      else if CStr[i]=Chr($0A) then Write(DGSYS.GraphicFp,'\r')
      else if (CStr[i]='\') and not IsKanji2(CStr,i) then Write(DGSYS.GraphicFp,'\\')
      else Write(DGSYS.GraphicFp,CStr[i]);
    Write(DGSYS.GraphicFp,',');
  end else for i:=1 to CPar[1] do begin
      Str(CPar[i+1],S);
      Write(DGSYS.GraphicFp,S,',');
  end;
  WriteLn(DGSYS.GraphicFp);
  if CCod='E' then begin
      Close(DGSYS.GraphicFp);
      Error:=IOErrorCheck;
  end;
end;

procedure nDraw;

            function Trans(x:Real):Integer;
            begin
              Trans:=Round(x*Mm2dot(NGRAPH.RegionSize)/PaperSize);
            end;

var i:Integer;
begin
  if DGSYS.Device<>0 then begin
      case CCod of
        'I','E','%','O','S','X': ;
        'V': begin
               CPar[2]:=Trans(CPar[2])+Mm2dot(NGRAPH.LeftMargin);
               CPar[3]:=Trans(CPar[3])+Mm2dot(NGRAPH.TopMargin);
               CPar[4]:=Trans(CPar[4])+Mm2dot(NGRAPH.LeftMargin);
               CPar[5]:=Trans(CPar[5])+Mm2dot(NGRAPH.TopMargin);
             end;
        'A': CPar[3]:=Trans(CPar[3]);
        'L','B':
             begin
               CPar[2]:=Trans(Cpar[2]);
               CPar[3]:=Trans(Cpar[3]);
               CPar[4]:=Trans(Cpar[4]);
               CPar[5]:=Trans(Cpar[5]);
             end;
        'T','M','N','P':
             begin
               CPar[2]:=Trans(Cpar[2]);
               CPar[3]:=Trans(Cpar[3]);
             end;
        'C': begin
               CPar[2]:=Trans(Cpar[2]);
               CPar[3]:=Trans(Cpar[3]);
               CPar[4]:=Trans(Cpar[4]);
               if CPar[1]>=5 then CPar[6]:=Trans(CPar[6]);
             end;
        'D': for i:=1 to CPar[2]*2 do CPar[i+3]:=Trans(CPar[i+3]);
        'F': begin
               CPar[4]:=Trans(Cpar[4]);
               CPar[5]:=Trans(Cpar[5]);
               CPar[8]:=Trans(Cpar[8]);
               CPar[9]:=Trans(Cpar[9]);
             end;
      end;
  end;
  case DGSYS.Device of
    0: gDraw;
    1: GraphicOut;
  end;
end;

procedure nOpenGraph;
begin
  nResetTextStyle;
  CCod:='I';
  CPar[1]:=3;
  CPar[2]:=Mm2dot(NGRAPH.LeftMargin);
  CPar[3]:=Mm2dot(NGRAPH.TopMargin);
  CPar[4]:=Mm2dot(NGRAPH.RegionSize);
  nDraw;
end;

procedure nCloseGraph;
begin
  CCod:='E';
  CPar[1]:=0;
  nDraw;
end;

procedure nRemark(Str:String);
begin
  CCod:='%';
  CPar[1]:=-1;
  CStr:=Str;
  nDraw;
end;

procedure nSetWriteMode(Mode:Integer);
begin
  CCod:='X';
  CPar[1]:=1;
  CPar[2]:=Mode;
  nDraw;
end;

procedure nPutImage(x,y:Integer;Color:Word);
begin
  CCod:='X';
  CPar[1]:=2;
  CPar[2]:=x;
  CPar[3]:=y;
  CPar[4]:=Color;
  nDraw;
end;

procedure nSetWindow(minx,miny,maxx,maxy:Real);
var x1,y1,x2,y2:Integer;
begin
   x1:=Mm2dot(NGRAPH.ViewX1);
   y1:=Mm2dot(NGRAPH.ViewY1);
   x2:=x1+Mm2dot(NGRAPH.Sizex);
   y2:=y1+Mm2dot(NGRAPH.Sizey);
   UseWindow(x1,y1,x2,y2);
   SetWindow(minx,maxy,maxx,miny);
end;

procedure nSetWindowAll;
begin
  UseWindow(0,0,PaperSize,PaperSize);
  SetWindow(0,PaperSize,PaperSize,0);
end;

procedure nSetWindowFull;
begin
  UseWindow(0,0,PaperSize,PaperSize);
  SetWindow(0,0,PaperSize,PaperSize);
end;

procedure nSetViewPort;
var x1,y1,x2,y2:Integer;
begin
  x1:=Mm2dot(NGRAPH.ViewX1);
  y1:=Mm2dot(NGRAPH.ViewY1);
  x2:=x1+Mm2dot(NGRAPH.Sizex);
  y2:=y1+Mm2dot(NGRAPH.Sizey);
  CCod:='V';
  CPar[1]:=5;
  Cpar[2]:=x1;
  Cpar[3]:=y1;
  Cpar[4]:=x2;
  Cpar[5]:=y2;
  CPar[6]:=0;
  nDraw;
  nResetTextStyle;
end;

procedure nReSetViewPort;
begin
  CCod:='V';
  CPar[1]:=5;
  CPar[2]:=0;
  CPar[3]:=0;
  CPar[4]:=PaperSize;
  CPar[5]:=PaperSize;
  CPar[6]:=1;
  nDraw;
  nResetTextStyle;
end;

procedure nSetLineStyle(Typ,Width,Col,Cap:Integer);
begin
  CCod:='A';
  CPar[1]:=4;
  CPar[2]:=Typ;
  CPar[3]:=Width;
  CPar[4]:=Col;
  CPar[5]:=Cap;
  TextCol:=Col;
  nDraw;
end;

procedure nSetFillColor(Col:Integer);
begin
  CCod:='O';
  CPar[1]:=1;
  CPar[2]:=Col;
  nDraw;
end;

procedure nLine(x0,y0,x1,y1:Real);
begin
  if LineClippingReal(x0,y0,x1,y1) then begin
      CCod:='L';
      CPar[1]:=4;
      CPar[2]:=XToG(x0);
      CPar[3]:=YToG(y0);
      CPar[4]:=XToG(x1);
      CPar[5]:=YToG(y1);
      nDraw;
  end;
end;

procedure nMarkLine(x0,y0,x1,y1:Real);
begin
  if WInXY((x0+x1)*0.5,(y0+y1)*0.5) then begin
      CCod:='L';
      CPar[1]:=4;
      CPar[2]:=XToG(x0);
      CPar[3]:=YToG(y0);
      CPar[4]:=XToG(x1);
      CPar[5]:=YToG(y1);
      nDraw;
  end;
end;

procedure nPutPixel(x,y:Real);
begin
   if WInXY(x,y) then begin
       CCod:='P';
       CPar[1]:=2;
       CPar[2]:=XToG(x);
       CPar[3]:=YToG(y);
       nDraw;
   end;
end;

procedure nCircle(x,y,r:Real;Fill:Boolean);
begin
   if WInXY(x,y) then begin
      CCod:='C';
      CPar[1]:=4;
      CPar[2]:=XToG(x);
      CPar[3]:=YToG(y);
      CPar[4]:=XScaleG(r);
      if Fill then CPar[5]:=1
              else CPar[5]:=0;
      nDraw;
   end;
end;

procedure nDrawPoly(NumPoints:Integer;var PolyPoints:Po;Fill:Boolean);
var i:Integer;
    xm,ym:Real;
begin
   xm:=0;
   ym:=0;
   for i:=1 to NumPoints do begin
     xm:=xm+PolyPoints[i].x;
     ym:=ym+PolyPoints[i].y;
   end;
   if WInXY(xm/NumPoints,ym/NumPoints) then begin
       CCod:='D';
       CPar[1]:=NumPoints*2+2;
       CPar[2]:=NumPoints;
       if Fill then CPar[3]:=1
               else CPar[3]:=0;
       for i:=1 to NumPoints do begin
           CPar[i*2+2]:=XToG(PolyPoints[i].x);
           CPar[i*2+3]:=YToG(PolyPoints[i].y);
       end;
       nDraw;
   end;
end;

procedure nRectAngle(x0,y0,x1,y1:Real;Fill:Boolean);
begin
  if BarClippingReal(x0,y0,x1,y1) then begin
       CCod:='B';
       CPar[1]:=5;
       CPar[2]:=XToG(x0);
       CPar[3]:=YToG(y0);
       CPar[4]:=XToG(x1);
       CPar[5]:=YToG(y1);
       if Fill then CPar[6]:=1
               else CPar[6]:=0;
       nDraw;
  end;
end;

procedure nSquare(x0,y0,x1,y1:Real;Fill:Boolean);
begin
  if WInXY((x0+x1)*0.5,(y0+y1)*0.5) then begin
       CCod:='B';
       CPar[1]:=5;
       CPar[2]:=XToG(x0);
       CPar[3]:=YToG(y0);
       CPar[4]:=XToG(x1);
       CPar[5]:=YToG(y1);
       if Fill then CPar[6]:=1
               else CPar[6]:=0;
       nDraw;
  end;
end;

procedure nLineTo(x1,y1:Real);
var x0,y0,xs,ys:Real;
begin
   x0:=GGetX;
   y0:=GGetY;
   xs:=x1;
   ys:=y1;
   if LineClippingReal(x0,y0,x1,y1) then begin
       if WInXY(GGetX,GGetY) then begin
           CCod:='T';
           CPar[1]:=2;
           CPar[2]:=XToG(x1);
           CPar[3]:=YToG(y1);
           nDraw;
       end else begin
           CCod:='L';
           CPar[1]:=4;
           CPar[2]:=XToG(x0);
           CPar[3]:=YToG(y0);
           CPar[4]:=XToG(x1);
           CPar[5]:=YToG(y1);
           nDraw;
           CCod:='M';
           CPar[1]:=2;
           CPar[2]:=XToG(x1);
           CPar[3]:=YToG(y1);
           nDraw;
       end;
   end;
   GMoveTo(xs,ys);
end;

procedure nMoveTo(x1,y1:Real);
begin
   if WInXY(x1,y1) then begin
     CCod:='M';
     CPar[1]:=2;
     CPar[2]:=XToG(x1);
     CPar[3]:=YToG(y1);
     nDraw;
   end;
   GMoveTo(x1,y1);
end;

procedure nLine2(x0,y0,x1,y1:Integer);
begin
  if LineClipping(x0,y0,x1,y1) then begin
    CCod:='L';
    CPar[1]:=4;
    CPar[2]:=x0;
    CPar[3]:=y0;
    CPar[4]:=x1;
    CPar[5]:=y1;
    nDraw;
  end;
end;

procedure nRectAngle2(x0,y0,x1,y1:Integer;Fill:Boolean);
begin
  if BarClipping(x0,y0,x1,y1) then begin
       CCod:='B';
       CPar[1]:=5;
       CPar[2]:=x0;
       CPar[3]:=y0;
       CPar[4]:=x1;
       CPar[5]:=y1;
       if Fill then CPar[6]:=1
               else CPar[6]:=0;
       nDraw;
  end;
end;

procedure nMoveTo2(x1,y1:Integer);
begin
  if GInXY(x1,y1) then begin
    CCod:='M';
    CPar[1]:=2;
    CPar[2]:=x1;
    CPar[3]:=y1;
    nDraw;
  end;
  GMoveTo(GToX(x1),GToY(y1));
end;

procedure nMoveRel2(x,y:Integer);
begin
  CCod:='N';
  CPar[1]:=2;
  CPar[2]:=x;
  CPar[3]:=y;
  nDraw;
  GMoveRel(GScaleX(x),GScaleY(y));
end;

procedure nResetTextStyle;
begin
  TextFont:=-1;
  TextSize100:=-1;
  TextDir:=-1;
  TextType:=-1;
  TextSpace100:=-10000;
  TextCol:=-1;
end;

procedure nSetTextStyle(Font,Dir,Pt,Typ,SpPt,Col:Integer);
begin
      if (Font<>TextFont) or (TextDir<>Dir) or (TextSize100<>Pt*100)
         or (Typ<>TextType) or (SpPt*100<>TextSpace100) or (Col<>TextCol) then begin
          TextFont:=Font;
          TextDir:=Dir;
          TextSize100:=Pt*100;
          TextType:=Typ;
          TextSpace100:=SpPt*100;
          TextCol:=Col;
          CCod:='F';
          CPar[1]:=8;
          CPar[2]:=Font;
          CPar[3]:=Typ;
          CPar[4]:=Pt;
          CPar[5]:=SpPt;
          CPar[6]:=Col;
          CPar[7]:=Dir;
          CPar[8]:=Pt*100;
          CPar[9]:=SpPt*100;
          nDraw;
      end;
end;

procedure nOutText(Str:String);
begin
  if WInXY(GGetX,GGetY) then begin
    CCod:='S';
    CPar[1]:=-1;
    CStr:=Str;
    nDraw;
  end;
end;

procedure nOutTextKanji(Str:String);
begin
  if WInXY(GGetX,GGetY) then begin
    CCod:='K';
    CPar[1]:=-1;
    CStr:=Str;
    nDraw;
  end;
end;

function nGetTextCode(Font,JFont,Size,Space,Typ,Col:Integer):Str20;
var S,S2:Str20;
begin
    S:='';
    case Font of
       Helvetica: S:=S+'%FH';
       Times    : S:=S+'%FT';
       Courier  : S:=S+'%FC';
    end;
    case JFont of
       Gothic   : S:=S+'%JG';
       Mincho   : S:=S+'%JM';
    end;
    Str(Size:2,S2);
    if S2[1]=' ' then S2[1]:='0';
    S:=S+'%S'+S2+'%P';
    Space:=Trunc(RangeCheck(Space,-99,99));
    if Space>=0 then S:=S+'+'
                else S:=S+'-';
    Space:=Abs(Space);
    Str(Space:2,S2);
    if S2[1]=' ' then S2[1]:='0';
    S:=S+S2;
    case Typ of
       Roman : S:=S+'%R';
       Bold  : S:=S+'%B';
       Italic: S:=S+'%I';
       BoldItalic: S:=S+'%O';
    end;
    Col:=Trunc(RangeCheck(Col,0,7));
    S:=S+'%C'+Chr(Col+Ord('0'));
    nGetTextCode:=S;
end;

function nGetTextStyle(Str:String;var Font,JFont,Size,Space,Typ,Col:Integer):Integer;
var j,Len,a,code:Integer;
begin
    Len:=Length(Str);
    j:=1;
    repeat
        if (j<=Len) and (Str[j]='%') then begin
            if (j<Len) and (Str[j+1] in ['R','B','I','O','r','b','i','o']) then begin
                case Upcase(Str[j+1]) of
                    'R': Typ:=Roman;
                    'B': Typ:=Bold;
                    'I': Typ:=Italic;
                    'O': Typ:=BoldItalic;
                end;
                Inc(j,2);
            end else if (j<Len-3) and (Str[j+1] in ['P','p'])
                       and (Str[j+2] in ['+','-'])
                       and (Str[j+3] in ['0'..'9'])
                       and (Str[j+4] in ['0'..'9']) then begin
                Space:=(Ord(Str[j+3])-Ord('0'))*10+Ord(Str[j+4])-Ord('0');
                if (Str[j+2]='-') then Space:=Space*(-1);
                Inc(j,5);
            end else if (j<Len-1) and (Str[j+1] in ['C','c'])
                       and (Str[j+2] in ['0'..'7']) then begin
                Col:=Ord(Str[j+2])-Ord('0');
                Inc(j,3);
            end else if (j<Len-1) and (Str[j+1] in ['F','f'])
                       and (Str[j+2] in ['H','h','T','t','C','c']) then begin
                case Upcase(Str[j+2]) of
                    'H': Font:=Helvetica;
                    'T': Font:=Times;
                    'C': Font:=Courier;
                end;
                Inc(j,3);
            end else if (j<Len-1) and (Str[j+1] in ['J','j'])
                       and (Str[j+2] in ['G','g','M','m']) then begin
                case Upcase(Str[j+2]) of
                    'G': JFont:=Gothic;
                    'M': JFont:=Mincho;
                end;
                Inc(j,3);
            end else if (j<Len-2) and (Str[j+1] in ['S','s'])
                       and (Str[j+2] in ['0'..'9'])
                       and (Str[j+3] in ['0'..'9']) then begin
                Size:=(Ord(Str[j+2])-Ord('0'))*10+Ord(Str[j+3])-Ord('0');
                Inc(j,4);
            end else if (j<=Len) then Inc(j);
        end;
    until (j>Len) or (Str[j]<>'%');
    nGetTextStyle:=j-1;
end;

function AddString(Str:String;Fst:Integer):String;

           function GetColumn(Str:String;Col:Integer):String;
           var ds,de,Dim:Integer;
               Error:Boolean;
           begin
             if Col=0 then GetColumn:=Str
             else begin
                 de:=1;
                 Dim:=0;
                 while (Dim<Col) do begin
                    Inc(Dim);
                    ds:=de;
                    while (ds<=Length(Str)) and (Str[ds] in [' ',Chr(9),',','(',')']) do Inc(ds);
                    de:=ds;
                    while (de<=Length(Str)) and not (Str[de] in [' ',Chr(9),',','(',')'] ) do Inc(de);
                    if Dim=Col then GetColumn:=Copy(Str,ds,de-ds);
                 end;
             end;
           end;

var i,j,k,Len,Fil,Lin:Integer;
    S,S2:String;
    Fp:Text;
    Time:LongInt;
    T:TDateTime;
    Hour,Min,Sec,Sec100:Word;
    Year,Month,Day,Week:Word;
    Error:Boolean;
    SRec:TSearchRec;
    DError:Integer;
    H:Integer;
begin
   Len:=Length(Str);
   S:='';
   j:=1;
   repeat
       i:=j;
       While (j<=Len) and not ( (Str[j] in ['\','%']) and not IsKanji2(Str,j) ) do Inc(j);
       S:=S+Copy(Str,i,j-i);
       if (j<Len) and (Str[j]='\') then begin
	   if Str[j+1]='b' then S:=S+''
           else if Str[j+1]='.' then S:=S+' '
           else if Str[j+1]=Chr($27) then S:=S+','
           else if Str[j+1]='[' then S:=S+'('
           else if Str[j+1]=']' then S:=S+')'
           else S:=S+'\'+Str[j+1];
	   Inc(j,2);
       end else if (j<Len-2) and (Str[j]='%') and (Str[j+1] in ['0'..'2']) and (Str[j+2] in ['0'..'9']) then begin
	   Fil:=( Ord(Str[j+1])-Ord('0') )*10+Ord(Str[j+2])-Ord('0');
           if Fil=0 then Fil:=Fst;
           if (0<Fil) and (Fil<=maxfil) then begin
	       if Str[j+3] in ['n','N'] then begin
                 if Fil<=FilePar.Num then begin
		   case Str[j+3] of
		      'n' : S2:=MakeFileName2(FilePar.Body[Fil].Name);
		      'N' : S2:=FilePar.Body[Fil].Name;
                   end;
                   for k:=1 to Length(S2) do
                       if S2[k] in ['\','^','_','@','%'] then S:=S+'\'+S2[k]
                                                         else S:=S+S2[k];
                 end;
		 Inc(j,4);
	       end else if (Str[j+3] in ['t','T','d','D']) then begin
                 if Fil<=FilePar.Num then begin
		   H:=FileOpen(FilePar.Body[Fil].Name,fmOpenRead);
		   Time:=0;
                   Time:=FileGetDate(H);
                   T:=FileDateToDateTime(Time);
                   FileClose(H);
		   Error:=IOErrorCheck;
                   DecodeDate(T,Year,Month,Day);
                   DecodeTime(T,Hour,Min,Sec,Sec100);
		   case Str[j+3] of
			't': S:=S+cTime2(Hour,Min);
			'T': S:=S+cTime(Hour,Min);
			'd': S:=S+cDate2(Year,Month,Day);
			'D': S:=S+cDate3(Year,Month,Day);
		   end;
                 end;
		 Inc(j,4);
	       end else if (j<Len-6) and (Str[j+3] in ['c','C']) and (Str[j+4] in ['0'..'9']) and (Str[j+5] in ['0'..'9'])
                                     and (Str[j+6] in ['0'..'9']) and (Str[j+7] in ['0'..'9']) then begin
                 if Fil<=FilePar.Num then begin
		   Assign(Fp,FilePar.Body[Fil].Name);
		   ReSet(Fp);
		   Lin:=( Ord(Str[j+4])-Ord('0') )*10 + Ord(Str[j+5])-Ord('0');
		   S2:='';
		   for k:=1 to Lin do ReadLn(Fp,S2);
		   Close(Fp);
		   Error:=IOErrorCheck;
		   Insert(GetColumn(S2,(Ord(Str[j+6])-Ord('0'))*10+Ord(Str[j+7])-Ord('0')),Str,j+8);
                   Len:=Length(Str);
                 end;
		 Inc(j,8);
	      end else begin
		   S:=S+'%';
		   Inc(j);
	      end;
	  end else begin
	      S:=S+'%';
	      Inc(j);
	  end;
      end else if (j<Len) and (Str[j]='%') and (Str[j+1] in ['t','T','d','D','m','M','v','V']) then begin
          if Upcase(Str[j+1]) in ['T','D'] then begin
            T:=Now;
            DecodeDate(T,Year,Month,Day);
            DecodeTime(T,Hour,Min,Sec,Sec100);
            Week:=DayOfWeek(T)-1;
          end else if Str[j+1]='m' then S2:=MakeFileName2(DGSYS.ParamFile)
          else if Str[j+1]='M' then S2:=FExpand(DGSYS.ParamFile)
          else if Upcase(Str[j+1])='V' then begin
            DError:=FindFirst('*.*',faVolumeID,SRec);
            FindClose(SRec);
            if DError=0 then begin
              S2:=Srec.Name;
              Delete(S2,9,1);
            end else S2:='';
          end;
	  case Str[j+1] of
            't': S:=S+cTime2(Hour,Min);
	    'T': S:=S+cTime(Hour,Min);
	    'd': S:=S+cDate2(Year,Month,Day);
	    'D': S:=S+cDate(Year,Month,Day,Week);
            'm','M','v','V':
                 for k:=1 to Length(S2) do
                   if S2[k] in ['\','^','_','@','%'] then S:=S+'\'+S2[k]
                                                     else S:=S+S2[k];
	  end;
	  Inc(j,2);
      end else if (j<=Len) then begin
	  S:=S+Str[j];
	  Inc(j);
      end;
   until (j>Len);
   AddString:=S;
end;

procedure nTextSize(var H,W:Integer;Str:String;Init,Script:Str20;Fst:Integer);
var i,j,tmp,Len,HH,Scmove,Sp,BW:Integer;
    WW:Real;
    ScriptF,Kanji:Boolean;
    Font,JFont,Size,Space,Typ,Col:Integer;
    S,S2:String;
    SS:Str20;

begin
   Str:=AddString(Str,Fst);
   ScriptF:=False;
   tmp:=nGetTextStyle(Init,Font,JFont,Size,Space,Typ,Col);
   H:=0;
   WW:=0;
   Len:=Length(Str);
   if Len=0 then begin
       W:=Pt2dot(nTextWidth(Font,Typ,Size,' '));
       H:=Pt2dot(nTextHeight(Font,Typ,Size));
       exit;
   end;
   j:=1;
   Sp:=0;
   repeat
       S:='';
       Kanji:=IsKanji(Word(Str[j]));
       While (j<=Len) and not ((Str[j] in ['','_','^','@','%']) and not IsKanji2(Str,j))
             and ( (Kanji and IsKanji(Word(Str[j])))
                  or (not Kanji and (not IsKanji(Word(Str[j])) or ((Str[j]='\') and (j<Len)))  ) )
             do begin
           if Kanji then begin
               S:=S+Copy(Str,j,2);
               Inc(j,2);
           end else if Str[j]='\' then begin
               S:=S+Copy(Str,j+1,1);
               Inc(j,2);
           end else begin
               S:=S+Str[j];
               Inc(j);
           end;
       end;
       if Length(S)<>0 then begin
           Sp:=Pt2dot(Space);
           if Kanji then for i:=1 to Length(S) div 2 do begin
               WW:=WW+Pt2dot(nTextWidth(JFont,Typ,Size,S[i*2-1]))+Sp;
               HH:=Pt2dot(nTextHeight(JFont,Typ,Size));
               if ScriptF then Inc(HH,Scmove);
               if H<HH then H:=HH;
           end else for i:=1 to Length(S) do begin
               WW:=WW+Pt2Dot(nTextWidth(Font,Typ,Size,S[i]))+Sp;
               HH:=Pt2dot(nTextHeight(Font,Typ,Size));
               if ScriptF then Inc(HH,Scmove);
               if H<HH then H:=HH;
           end;
       end;
       if j<=Len then begin
           if (Str[j]='') then begin
               if Kanji then BW:=Pt2Dot(nTextWidth(JFont,Typ,Size,' '))+Pt2dot(Space)
                        else BW:=Pt2Dot(nTextWidth(Font ,Typ,Size,' '))+Pt2dot(Space);
               WW:=WW-BW;
               Inc(j);
           end else if (Str[j] in ['^','_','@']) then begin
               case Str[j] of
                  '^','_': if not ScriptF then begin
                               if Str[j]='^' then begin
                                   if Kanji then Scmove:=Pt2dot(nTextHeight(JFont,Typ,Size)*1.7/3)
                                            else Scmove:=Pt2dot(nTextHeight(Font, Typ,Size)*1.7/3);
                               end else Scmove:=0;
                               ScriptF:=True;
                               SS:=nGetTextCode(Font,JFont,Size,Space,Typ,Col);
                               tmp:=nGetTextStyle(Script,Font,JFont,Size,Space,Typ,Col);
                            end;
                  '@': if ScriptF then begin
                               tmp:=nGetTextStyle(SS,Font,JFont,Size,Space,Typ,Col);
                               ScriptF:=False;
                        end;
               end;
               Inc(j);
           end else if (Str[j]='%') then begin
               if (j<Len) and (Upcase(Str[j+1]) in ['F','J','S','P','R','B','I','O','C']) then begin
                   S2:=Copy(Str,j,Len-j+1);
                   Inc(j,nGetTextStyle(S2,Font,JFont,Size,Space,Typ,Col));
               end else if (j<Len-3) and (Upcase(Str[j+1]) in ['X','Y'])
                   and (Str[j+2] in ['+','-']) and (Str[j+3] in ['0'..'9'])
                   and (Str[j+4] in ['0'..'9']) then begin
                   Inc(j,5);
               end else Inc(j);
           end;
       end;
   until (j>Len);
   if (WW>0) then WW:=WW-Sp;
   if WW<-PaperSize then WW:=-PaperSize
   else if WW>PaperSize then WW:=PaperSize;
   W:=Round(WW);
end;

procedure SelectNormal(Dir:Integer);
begin
    if ScriptMove<>0 then begin
        if Dir=HorizontalDir then nMoveRel2(0,-ScriptMove)
	                     else nMoveRel2(-ScriptMove,0);
        ScriptMove:=0;
    end;
end;

procedure SelectScript(Font,Typ,Dir,Size:Integer;Super:Boolean);
begin
    if Super then ScriptMove:=-Pt2dot(nTextHeight(Font,Typ,Size)*1.7/3)
	     else ScriptMove:=Pt2dot(nTextHeight(Font,Typ,Size)/3.5);
    if dir=HorizontalDir then nMoveRel2(0,ScriptMove)
		         else nMoveRel2(ScriptMove,0);
end;

procedure nOutString(Str:String;Init,Script:Str20;Dir:integer;Clear:Boolean;Fst:Integer);
var j,k,Len,tmp,W,M,code:Integer;
    S,S2:String;
    SS:Str20;
    Font,JFont,Size,Space,Typ,Col,C:Integer;
    ScriptF,Kanji:Boolean;

begin
   Str:=AddString(Str,Fst);
   ScriptMove:=0;
   ScriptF:=False;
   tmp:=nGetTextStyle(Init,Font,JFont,Size,Space,Typ,Col);
   Len:=Length(Str);
   if Len=0 then exit;
   Kanji:=False;
   j:=1;
   repeat
       S:='';
       Kanji:=IsKanji(Word(Str[j]));
       While (j<=Len) and not ((Str[j] in ['','_','^','@','%']) and not IsKanji2(Str,j))
             and ( (Kanji and IsKanji(Word(Str[j])))
                  or (not Kanji and (not IsKanji(Word(Str[j])) or ((Str[j]='\') and (j<Len)))  ) )
             do
           if Kanji then begin
               S:=S+Copy(Str,j,2);
               Inc(j,2);
           end else if Str[j]='\' then begin
               S:=S+Copy(Str,j+1,1);
               Inc(j,2);
           end else begin
               S:=S+Str[j];
               Inc(j);
           end;
       if Length(S)<>0 then begin
           if Clear then C:=7
                    else C:=Col;
           if Kanji then begin
               nSetTextStyle(JFont,Dir,Size,Typ,Space,C);
               nOutTextKanji(S);
           end else begin
               nSetTextStyle(Font,Dir,Size,Typ,Space,C);
               nOutText(S);
           end;
       end;
       if j<=Len then begin
           if (Str[j]='') then begin
               if Kanji then W:=Pt2dot(nTextWidth(JFont,Typ,Size,'+'))+Pt2dot(Space)
                        else W:=Pt2dot(nTextWidth(Font ,Typ,Size,'+'))+Pt2dot(Space);
               if Dir=HorizontalDir then nMoveRel2(-W,0)
                                    else nMoveRel2(0,W);
               Inc(j);
           end else if (Str[j] in ['^','_','@']) then begin
               case Str[j] of
                  '^','_': if not ScriptF then begin
                               if Str[j]='^' then begin
                                   if Kanji then SelectScript(JFont,Typ,Dir,Size,True)
                                            else SelectScript(Font,Typ,Dir,Size,True);
                               end else begin
                                   if Kanji then SelectScript(JFont,Typ,Dir,Size,False)
                                            else SelectScript(Font,Typ,Dir,Size,False);
                               end;
                               SS:=nGetTextCode(Font,JFont,Size,Space,Typ,Col);
                               ScriptF:=True;
                               tmp:=nGetTextStyle(Script,Font,JFont,Size,Space,Typ,Col);
                           end;
                  '@': if ScriptF then begin
                               SelectNormal(Dir);
                               tmp:=nGetTextStyle(SS,Font,JFont,Size,Space,Typ,Col);
                               ScriptF:=False;
                        end;
               end;
               Inc(j);
           end else if (Str[j]='%') then begin
               if (j<Len) and (Upcase(Str[j+1]) in ['F','J','S','P','R','B','I','O','C']) then begin
                   S2:=Copy(Str,j,Len-j+1);
                   Inc(j,nGetTextStyle(S2,Font,JFont,Size,Space,Typ,Col));
               end else if (j<Len-3) and (Upcase(Str[j+1]) in ['X','Y'])
                   and (Str[j+2] in ['+','-']) and (Str[j+3] in ['0'..'9'])
                   and (Str[j+4] in ['0'..'9']) then begin
                   S2:=Copy(Str,j+2,3);
                   Val(S2,M,code);
                   if code=0 then begin
                       if Upcase(Str[j+1])='X' then nMoveRel2(Pt2dot(M),0)
                                               else nMoveRel2(0,Pt2dot(M))
                   end;
                   Inc(j,5);
               end else Inc(j);
           end;
       end;
   until (j>Len);
end;

end.