(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* ŏ@葱 *)

unit LSTSQR;

interface

uses Crt,PullMenu,Data,Math,Variable,Display;

Type Real=Double;

procedure LeastSqr(Mode:Integer;xp,yp:Real);
function  LeastFn(x:Real;var y:Real):Boolean;
procedure LSQDispFirst;
procedure LSQDispNext(N:Integer);

implementation

var LSQMenu:array [0..18] of String[24];

procedure LSQDispFirst;
var i,y:Integer;
    S:String;
begin
    for i:=0 to 19 do LSQMenu[i]:='';
    PullColor:=Color2.WindowInput;
    if LSQPar.Typ=9 then y:=THeight-9-LSQPar.Dim*2
                    else y:=THeight-8-LSQPar.Dim;
    OpenWindow(1,y,25,THeight-4-y);
    SetMenuString(1,19,24,-1,19,LSQMenu);
    MakeFrame('LEAST SQUARE FIT','');
    ClearFrame;
    Str((LSQPar.Dim-1):1,S);
    case LSQPar.Typ of
        0: PullWriteXYW(2,2,'     Y = A0 + A1*X',Color2.WindowInput.Back);
     1..5: PullWriteXYW(2,2,'Y =  Ai * X^i (i=0~'+S+')',Color2.WindowInput.Back);
        6: PullWriteXYW(2,2,'Ln(Y) = A0 + A1*Ln(X)',Color2.WindowInput.Back);
        7: PullWriteXYW(2,2,'   Ln(Y) = A0 + A1*X',Color2.WindowInput.Back);
        8: PullWriteXYW(2,2,'    Y = A0 + A1*Ln(X)',Color2.WindowInput.Back);
        9: PullWriteXYW(2,2,'Y = f( X; %00 ~ %0'+S+' )',Color2.WindowInput.Back);
    end;
    case LSQPar.Typ of
        0: LSQMenu[0]:='     Y = A0 + A1*X';
     1..5: LSQMenu[0]:='Y =  Ai * X^i (i=0~'+S+')';
        6: LSQMenu[0]:='Ln(Y) = A0 + A1*Ln(X)';
        7: LSQMenu[0]:='   Ln(Y) = A0 + A1*X';
        8: LSQMenu[0]:='    Y = A0 + A1*Ln(X)';
        9: LSQMenu[0]:='Y = f( X; %00 ~ %0'+S+' )';
    end; 
end;

procedure LSQDispNext(N:Integer);
var i,y,y2:Integer;
    S,S2:String;
begin
    if LSQPar.Typ=9 then begin
        y:=2;
        y2:=0;
        for i:=1 to LSQPar.Dim do begin
            Str((i-1):1,S);
            Str(LSQPar.Coe[i]:15,S2);
            S:=S+' : '+S2;
            PullWriteXYW(5,y+i,'%0'+S,Color2.WindowInput.Back);
            LSQMenu[y2+i]:='   %0'+S;
        end;
        y:=y+LSQPar.Dim;
        y2:=y2+LSQPar.Dim;
        for i:=1 to LSQPar.Dim do begin
            Str((i-1):1,S);
            Str(LSQPar.CoeError[i]:15,S2);
            S:=S+' : '+S2;
            PullWriteXYW(3,y+i,'%0'+S,Color2.WindowInput.Back);
            LSQMenu[y2+i]:=' %0'+S;
        end;
        y:=y+LSQPar.Dim+1;
        y2:=y2+LSQPar.Dim+1;
        Str(N:6,S);
        PullWriteXYW(3,y,'Iterate:'+S,Color2.WindowInput.Back);
        LSQMenu[y2]:=' Iterate:'+S;
    end else begin
        y:=2;
        y2:=0;
        for i:=1 to LSQPar.Dim do begin
            Str((i-1):1,S);
            Str(LSQPar.Coe[i]:15,S2);
            S:=S+' : '+S2;
            PullWriteXYW(4,y+i,' A'+S,Color2.WindowInput.Back);
            LSQMenu[y2+i]:='   A'+S;
        end;
        y:=y+LSQPar.Dim;
        y2:=y2+LSQPar.Dim;
    end;
    Str(LSQPar.ExitCode:6,S);
    PullWriteXYW(4,y+1,'Points:'+S,Color2.WindowInput.Back);
    LSQMenu[y2+1]:='  Points:'+S;
    Str(LSQPar.Error:15,S);
    PullWriteXYW(3,y+2,'Y^2:'+S,Color2.WindowInput.Back);
    LSQMenu[y2+2]:=' Y^2:'+S;
    if LSQPar.Correlation>=0 then Str(LSQPar.Correlation:15,S)
                             else S:='---------------';
    PullWriteXYW(7,y+3,'|r|:'+S,Color2.WindowInput.Back);
    LSQMenu[y2+3]:='  |r|:'+S;
end;


procedure LeastSqr(Mode:Integer;xp,yp:Real);
var x,xx,dxx,y,yy,Sy:Real;
    y1,y2,y3:Real;
    Num,N:LongInt;
    M,M2:Matrix;
    x1,x2,B:Vector;
    i,j,k:Integer;
    Error,Error2:Boolean;
    CalcCode,MaxDim,MaxDim2:Integer;
    Dummy:Byte;
    NeedData,NeedData2 :ByteSet;
    GetD,Need2Path:Boolean;
    Lin:LongInt;
    NAN:Boolean;
    MathStatus:Array [1..8] of ShortInt;
begin
  LSQPar.ExitCode:=-1;
  LSQPar.Error:=0;
  LSQPar.Correlation:=-1;
  for i:=1 to 8 do begin
      LSQPar.Coe[i]:=0;
      LSQPar.CoeError[i]:=0;
  end;
  AxisRawMode:=True;
  if LSQPar.Typ<>9 then begin
     if LSQPar.Typ in [0..5] then LSQPar.Dim:=LSQPar.Typ+2
     else if LSQPar.Typ in [6..8] then LSQPar.Dim:=2;
     Num:=0;
     yy:=0;
     xx:=0;
     for i:=1 to SizeOf(Vector) div SizeOf(Double) do begin
	 B[i]:=0;
	 for j:=1 to SizeOf(Vector) div SizeOf(Double) do M[i,j]:=0;
     end;
     Error2:=False;
     While GetData(x,y,Lin,NAN) do if not NAN then begin
	 Error:=False;
	 case LSQPar.Typ of
	   0..5: y1:=y;
	   6: if (y<=0) then Error:=True
	      else y1:=Ln(y);
	   7: if (y<=0) then Error:=True
	      else y1:=Ln(y);
	   8: y1:=y;
	 end;
	 x1[1]:=1;
	 case LSQPar.Typ of
	   0..5: for i:=2 to LSQPar.Dim do x1[i]:=x1[i-1]*x;
	   6: if (x<=0) then Error:=True
	      else x1[2]:=Ln(x);
	   7: x1[2]:=x;
	   8: if (x<=0) then Error:=True
	      else x1[2]:=Ln(x);
	 end;
	 if Error then Error2:=True
	 else begin
              xx:=xx+x1[2]*x1[2];
              yy:=yy+y1*y1;
	      for i:=1 to LSQPar.Dim do B[i]:=B[i]+y1*x1[i];
	      for i:=1 to LSQPar.Dim do
		  for j:=1 to LSQPar.Dim do M[i,j]:=M[i,j]+x1[i]*x1[j];
	      Num:=Num+1;
	 end;
     end;
     if Error2 then ErrorDisp('Warning: MATH Error in LSQ Transformation ->ignored');
     if Mode=1 then begin
	 case LSQPar.Typ of
	   0..5: y2:=yp;
	   6: if (yp<=0) then Error:=True
	      else y2:=Ln(yp);
	   7: if (yp<=0) then Error:=True
	      else y2:=Ln(yp);
	   8: y2:=yp;
	 end;
	 x2[1]:=1;
	 case LSQPar.Typ of
	   0..5: for i:=2 to LSQPar.Dim do x2[i]:=x2[i-1]*xp;
	   6: if (xp<=0) then Error:=True
	      else x2[2]:=Ln(xp);
	   7: x2[2]:=xp;
	   8: if (xp<=0) then Error:=True
	      else x2[2]:=Ln(xp);
	 end;
	 if Error then begin
             ErrorDisp('Error: Invalid constraint (Least Square Fit)');
             Exit;
         end;
         for i:=1 to LSQPar.Dim do begin
             M[i][LSQPar.Dim+1]:=x2[i];
             M[LSQPar.Dim+1][i]:=x2[i];
         end;
	 B[LSQPar.Dim+1]:=y2;
         LSQPar.Dim:=LSQPar.Dim+1;
     end;
     if Num=0 then begin
	 LSQPar.ExitCode:=0;
	 Exit;
     end else if Num<LSQPar.Dim then begin
         ErrorDisp('Error: Too Small Data Number (Least Square Fit)');
         Exit;
     end;
     if not MSolve(LSQPar.Dim,M,B,LSQPar.Coe) then begin
         ErrorDisp('Error: Singular Matrix (Least Square Fit)');
         exit;
     end;
     LSQPar.Error:=yy;
     for i:=1 to LSQPar.Dim do LSQPar.Error:=LSQPar.Error-LSQPar.Coe[i]*B[i];
     LSQPar.Error:=Abs(LSQPar.Error)/Num;
     Sy:=yy/Num-Sqr(B[1]/Num);
     if (Sy=0) or (1-LSQPar.Error/Sy<0) then LSQPar.Correlation:=-1
     else LSQPar.Correlation:=Sqrt(1-LSQPar.Error/Sy);
     LSQPar.Error:=Sqrt(LSQPar.Error);
     if Mode=1 then LSQPar.Dim:=LSQPar.Dim-1;
     LSQPar.ExitCode:=Num;
  end else if LSQPar.Typ=9 then begin
     Maxdim:=0;
     NeedData:=[];
     for i:=1 to SizeOf(MathStatus) div SizeOf(ShortInt) do MathStatus[i]:=0;
     Error:=not InterplitMath(LSQPar.FitExp[0],LSQMathCode[0]^,Maxdim,NeedData,Need2Path,0,100,0,True,False,True,False,True);
     if not (100 in NeedData) then Error:=True;
     NeedData:=NeedData-[100];
     MaxDim:=0;
     for i:=0 to 99 do if (i in NeedData) and (i>=Maxdim) then Maxdim:=i+1;
     for i:=0 to MaxDim-1 do if not (i in NeedData) then Error:=True;
     if Error then begin
	 ErrorDisp('Error: Syntax in Transformation (Fit equation)');
         Exit;
     end;
     if LSQPar.FitDif[1]='Y' then begin
         Error:=False;
         for i:=1 to MaxDim do begin
           Maxdim2:=0;
           NeedData2:=[];
           Error:=Error or not InterplitMath(LSQPar.FitExp[i],LSQMathCode[i]^,Maxdim2,NeedData2,Need2Path,0,0,0,
                                                                     True,False,True,False,True);
           if MaxDim2>=MaxDim then Error:=True;
         end;
         if Error then begin
	     ErrorDisp('Error: Syntax in Transformation (Fit derivative)');
	     Exit;
         end;
     end;
     LSQPar.Dim:=MaxDim;
     i:=0;
     Repeat
       GetD:=GetData(x,y,Lin,NAN);
       if GetD and not NAN and (i<DGSYS.SPMaximData) then begin
         spx^[i]:=x;
         spy^[i]:=y;
         Inc(i);
       end;
     until not GetD or GetD and not NAN and (i>=DGSYS.SPMaximData);
     if GetD and not NAN and (i>=DGSYS.SPMaximData) then ErrorDisp('Warning: Too large Data Size');
     DataNum:=i;
     if DataNum=0 then Exit;
     LSQPar.ExitCode:=0;
     for i:=1 to LSQPar.Dim do LSQPar.Coe[i]:=LSQPar.FitVal[i];
     N:=0;
     LSQDispFirst;
     LSQDispNext(N);
     repeat
         yy:=0;
         y:=0;
         y3:=0;
         for i:=1 to LSQPar.Dim do begin
           B[i]:=0;
           for j:=1 to LSQPar.Dim do M[i][j]:=0;
         end;
         Error2:=False;
         Num:=0;
         for i:=0 to DataNum-1 do begin
           Error:=False;
	   CalcCode:=Calculate(LSQMathCode[0]^,spx^[i],0,0,0,0,0,0,0,LSQPar.Coe,MathStatus,Dummy,Dummy,Dummy,Dummy,y1);
           if CalcCode=1 then begin
	       ErrorDisp('Error: Syntax in Transformation (Fit equation)');
               LSQPar.Exitcode:=-1;
               CloseWindow;
               Exit;
           end else if CalcCode<>0 then Error:=True;
           if LSQPar.FitDif[1]='Y' then begin
               for j:=1 to LSQPar.Dim do begin
                 CalcCode:=Calculate(LSQMathCode[j]^,spx^[i],0,0,0,0,0,0,0,
                                     LSQPar.Coe,MathStatus,Dummy,Dummy,Dummy,Dummy,x2[j]);
                 if CalcCode=1 then begin
	             ErrorDisp('Error: Syntax in Transformation (Fit derivative)');
                     LSQPar.Exitcode:=-1;
                     CloseWindow;
                     Exit;
                 end else if CalcCode<>0 then Error:=True;
               end;
           end else begin
               for j:=1 to LSQPar.Dim do begin
                 x1:=LSQPar.Coe;
                 dxx:=x1[j]*LSQPar.FitError*1E-6;
                 if dxx=0 then dxx:=1E-6;
                 x1[j]:=x1[j]+dxx;
                 CalcCode:=Calculate(LSQMathCode[0]^,spx^[i],0,0,0,0,0,0,0,x1,MathStatus,Dummy,Dummy,Dummy,Dummy,x2[j]);
                 if CalcCode=1 then begin
	             ErrorDisp('Error: Syntax in Transformation (Fit derivative)');
                     LSQPar.Exitcode:=-1;
                     CloseWindow;
                     Exit;
                 end else if CalcCode<>0 then Error:=True
                 else x2[j]:=(x2[j]-y1)/dxx;
               end;
           end;
           if not Error then begin
               Inc(Num);
               y2:=spy^[i]-y1;
               yy:=yy+Sqr(y2);
               y:=y+spy^[i];
               y3:=y3+Sqr(spy^[i]);
               for j:=1 to LSQPar.Dim do B[j]:=B[j]+x2[j]*y2;
               for j:=1 to LSQPar.Dim do for k:=1 to LSQPar.Dim do M[j][k]:=M[j][k]+x2[j]*x2[k];
           end else Error2:=True;
         end;
         if Error2 then ErrorDisp('Warning: MATH Error in LSQ Transformation ->ignored');
         if not MInv(LSQPar.Dim,M,M2) then begin
             ErrorDisp('Error: Singular Matrix (Least Square Fit)');
             LSQPar.Exitcode:=-1;
             CloseWindow;
             exit;
         end;
         dxx:=0;
         for i:=1 to LSQPar.Dim do begin
           LSQPar.CoeError[i]:=0;
           for j:=1 to LSQPar.Dim do LSQPar.CoeError[i]:=LSQPar.CoeError[i]+M2[i][j]*B[j];
           dxx:=dxx+LSQPar.CoeError[i]*LSQPar.CoeError[i];
           LSQPar.Coe[i]:=LSQPar.Coe[i]+LSQPar.CoeError[i];
           xx:=LSQPar.Coe[i]*LSQPar.Coe[i];
         end;
         dxx:=Sqrt(dxx);
         xx:=Sqrt(xx);
         Inc(N);
         if Num<>0 then begin
           LSQPar.Error:=Abs(yy)/Num;
           Sy:=y3/Num-Sqr(y/Num);
           if (Sy=0) or (1-LSQPar.Error/Sy<0) then LSQPar.Correlation:=-1
           else LSQPar.Correlation:=Sqrt(1-LSQPar.Error/Sy);
           LSQPar.Error:=Sqrt(LSQPar.Error);
         end;
         LSQPar.ExitCode:=Num;
         LSQDispNext(N);
     until KeyCheck or (dxx<=xx*LSQPar.FitError/100) 
     or (xx<=1E-6) and (dxx<=1E-6*LSQPar.FitError/100);
  end;
end;

function LeastFn(x:Real;var y:Real):Boolean;
var x1:Real;
    i:Integer;
    Error:Boolean;
    Dummy:Integer;
    MathStatus:Array [1..8] of ShortInt;
begin
  Error:=False;
  case LSQPar.Typ of
   0..5: begin
            y:=0;
            for i:=LSQPar.Dim downto 1 do y:=y*x+LSQPar.Coe[i];
         end;
      6: if (x=0) then begin
             if (LSQPar.Coe[2]>0) then y:=0
                                  else Error:=True;
         end else if x<0 then Error:=True
         else if (LSQPar.Coe[1]+LSQPar.Coe[2]*Ln(x))>690 then Error:=True
         else y:=Exp(LSQPar.Coe[1]+LSQPar.Coe[2]*Ln(x));
      7: begin
           y:=LSQPar.Coe[2]*x+LSQPar.Coe[1];
           if (Abs(y)>690) then Error:=True
           else y:=Exp(y);
         end;
      8: if x<=0 then Error:=True
         else y:=LSQPar.Coe[2]*Ln(x)+LSQPar.Coe[1];
      9: begin
           for i:=1 to SizeOf(MathStatus) div SizeOf(ShortInt) do MathStatus[i]:=0;
           if Calculate(LSQMathCode[0]^,x,0,0,0,0,0,0,0,LSQPar.Coe,MathStatus,Dummy,Dummy,Dummy,Dummy,y)<0 then Error:=True
         end;
  end;
  LeastFn:=not Error;
end;

end.
