(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C|File|j| *)

unit Mfile;

interface

uses DOSCall,Memory,Data,PullMenu,Variable,Display,ChildExe,Dialog,COption,IOProc,Quit;

Type Real=Double;

function SetFileBody(Sel:Integer):Boolean;

implementation

const

ReadFileMenu:array [0..1] of String[12]=
   ('Open default',
    'Format      ');

FileFormatMenu:array [0..0] of String[12+5]=
   ('File option:');

const AboutMenu: array[0..6] of String[32]=(
    '                          ',
    '  _/ Ngraph Version 5.46    ',
    '                          ',
    ' Copyright (C) S.Ishizaka, 1997 ',
    '       All rights reserved.     ',
    '   isizaka@msa.biglobe.ne.jp    ',
    '                                ');


function SetFileBody(Sel:Integer):Boolean;

var Fp:text;
    i,j,k,l,m:integer;
    Sel2,Sel3,filnum0,VAFCode:integer;
    Fil  :String;
    S,Command:String;
    Ch :Char;
    Shift:Boolean;
    SelFile :ByteSet;
    Fil2:PathStr;
    Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
    Error:Boolean;
    Com:ComType;
    ComMenu: array [1..5] of String[58];
    Path2:PathStr;
    ExitCode:Word;

const Path:PathStr='*.*';

begin
       if Sel=7 then SelectMode(True,True,False,True)
                else SelectMode(True,False,False,True);
       SetFileBody:=False;
       case Sel of

	  0: begin
		PullColor:=Color2.WindowInput;
                Fil:=Path;
		if WindowInput(PWinX,PWinY+1,30,Fil,'FILENAME','') then begin
                    filnum0:=FilePar.Num;
                    Path:=Fil;
                    FWild(Path,Dir,Name,Ext,'.*');
                    Path2:=Path;
                    if (Pos('*',Path2)<>0) or (Pos('?',Path2)<>0) then begin
                        PullColor:=Color2.Directory;
                        SelectFileSFirst(PWInX,PWInY+1,4,18,Path2);
                        repeat
                            Path2:=SelectFileSNext(Path2,'ESC:I CR:I SHIFT+CR:II',Shift);
                            if (FilePar.Num<maxfil) and (Length(Path2)>0) then begin
                               Inc(FilePar.Num);
                               FilePar.Body[FilePar.Num]:=FilePar.Body[0];
                               FilePar.Body[FilePar.Num].Name:=FExpand(Path2);
                               Fdisp(FilePar.Num,False);
                            end;
                        until (Length(Path2)=0) or Shift;
                        SelectFileSEnd;
                    end else if Length(Path2)<>0 then begin
                        if Find(Path2,True) then begin
                            Inc(FilePar.Num);
                            FilePar.Body[FilePar.Num]:=FilePar.Body[0];
                            FilePar.Body[FilePar.Num].Name:=FExpand(Path2);
                            Fdisp(FilePar.Num,False);
                        end;
                    end;
                    i:=filnum0+1;
                    While i<=FilePar.Num do begin
                       if Get5Line(i,Com) then With FilePar.Body[i] do begin
                           Fdisp(i,True);
                           Comment:=Com[1];
                           if DGSYS.FileOption[1]='Y' then begin
                               GetOption(Com[1],i);
                               if SkipNum=0 then SkipNum:=1;
                           end;
                           for j:=1 to 5 do ComMenu[j]:=Com[j];
                           PullColor:=Color2.Setting;
                           PullColor.Bar:=PullColor.Back;
                           SelectMenuSFirst(PWinX-1,1,1,5,58,0,5);
                           SelectMenuSDisp(0,0,ComMenu,Name,'');
                           Sel2:=SetFileParam(PWinX,PWinY+5,i,False);
                           SelectMenuSEnd;
                       end else Sel2:=16;
                       if Sel2=16 then begin
                           Dec(FilePar.Num);
                           for j:=i to FilePar.Num do FilePar.Body[j].Name:=FilePar.Body[j+1].Name;
                       end else Inc(i);
                       for j:=filnum0+1 to maxfil do Fdisp(j,False);
                    end;
                    SetFileBody:=True;
                end;
              end;

      1: begin
           PullColor:=Color2.WindowInput;
           Path:='NONAME.DAT';
           if GetFileName(PWinX,PWinY+2,Fil2,Path,'.*','NEW FILENAME') then begin
	       Command:=GetEnv('EDITOR');
	       if Command='' then Command:=GetEnv('EDIT');
	       if Command='' then Command:='Notepad';
               ExitCode:=Child(Command+' '+Fil2,'',True,False);
               if Find(Fil2,True) then begin
                   Inc(FilePar.Num);
                   FilePar.Body[FilePar.Num]:=FilePar.Body[0];
                   FilePar.Body[FilePar.Num].Name:=FExpand(Fil2);
                   if Get5Line(FilePar.Num,Com) then With FilePar.Body[FilePar.Num] do begin
                       Comment:=Com[1];
                       if DGSYS.FileOption[1]='Y' then begin
                           GetOption(Com[1],FilePar.Num);
                           if SkipNum=0 then SkipNum:=1;
                       end;
                   end;
                   SetFileBody:=True;
               end;
           end;
         end;

       2: begin
	      if SelectFile(False,SelFile,'CLOSE')>0 then begin
                    for j:=FilePar.Num downto 1 do
			 if j in SelFile then begin
			       for i:=j to FilePar.Num-1 do
				    FilePar.Body[i]:=FilePar.Body[i+1];
                               FilePar.Body[FilePar.Num]:=FilePar.Body[0];
                               for l:=Mask.Num downto 1 do begin
                                   if (Mask.Body[l].Fil=j) then begin
                                       for m:=l to Mask.Num-1 do Mask.Body[m]:=Mask.Body[m+1];
                                       Mask.Body[Mask.Num]:=Mask.Body[0];
                                       Dec(Mask.Num);
                                   end else if (Mask.Body[l].Fil>j) then Dec(Mask.Body[l].Fil);
                               end;
                               for l:=MaskReg.Num downto 1 do begin
                                   if (MaskReg.Body[l].Fil=j) then begin
                                       for m:=l to MaskReg.Num-1 do MaskReg.Body[m]:=MaskReg.Body[m+1];
                                       MaskReg.Body[MaskReg.Num]:=MaskReg.Body[0];
                                       Dec(MaskReg.Num);
                                   end else if (MaskReg.Body[l].Fil>j) then Dec(MaskReg.Body[l].Fil);
                               end;
                               for l:=ChgData.Num downto 1 do begin
                                   if (ChgData.Body[l].Fil=j) then begin
                                       for m:=l to ChgData.Num-1 do ChgData.Body[m]:=ChgData.Body[m+1];
                                       ChgData.Body[ChgData.Num]:=ChgData.Body[0];
                                       Dec(ChgData.Num);
                                   end else if (ChgData.Body[l].Fil>j) then Dec(ChgData.Body[l].Fil);
                               end;
			       Dec(FilePar.Num);
			 end;
		    SetFileBody:=True;
	      end;
	  end;

       3: begin
            Sel2:=SelectFile(False,SelFile,'UPDATE');
            if Sel2<>0 then begin
                for i:=1 to FilePar.Num do if i in SelFile then
                  if Get5Line(i,Com) then With FilePar.Body[i] do begin
		      Fdisp(i,True);
                      Comment:=Com[1];
                      for j:=1 to 5 do ComMenu[j]:=Com[j];
                      PullColor:=Color2.Setting;
                      PullColor.Bar:=PullColor.Back;
                      SelectMenuSFirst(PWinX-1,1,1,5,58,0,5);
                      SelectMenuSDisp(0,0,ComMenu,Name,'');
                      Sel3:=SetFileParam(PWinX,PWinY+5,i,True);
                      SelectMenuSEnd;
  		      Fdisp(i,False);
                  end;
		SetFileBody:=True;
            end;
	  end;

      4: if FilePar.Num>1 then repeat
           Sel2:=SelectFile(True,SelFile,'1ST FILE');
           if (Sel2>0) then begin
               FilePar.Body[maxfil+1]:=FilePar.Body[Sel2];
               for i:=Sel2-1 downto 1 do FilePar.Body[i+1]:=FilePar.Body[i];
               FilePar.Body[1]:=FilePar.Body[maxfil+1];
               for l:=1 to Mask.Num do
                   if (Mask.Body[l].Fil<Sel2) then Inc(Mask.Body[l].Fil)
                   else if (Mask.Body[l].Fil=Sel2) then Mask.Body[l].Fil:=1;
               for l:=1 to MaskReg.Num do
                   if (MaskReg.Body[l].Fil<Sel2) then Inc(MaskReg.Body[l].Fil)
                   else if (MaskReg.Body[l].Fil=Sel2) then MaskReg.Body[l].Fil:=1;
               for l:=1 to ChgData.Num do
                   if (ChgData.Body[l].Fil<Sel2) then Inc(ChgData.Body[l].Fil)
                   else if (ChgData.Body[l].Fil=Sel2) then ChgData.Body[l].Fil:=1;
	       SetFileBody:=True;
           end;
         until Sel2<=0;

      5: begin
	   Sel2:=SelectFile(True,SelFile,'LIST');
	   if (Sel2>0) then begin
	       Command:=GetEnv('PAGER');
	       if Command='' then Command:=GetEnv('MORE');
	       if Command='' then Command:='Notepad '+FilePar.Body[Sel2].Name
                             else Command:=Command+' '+FilePar.Body[Sel2].Name;
	       ExitCode:=Child(Command,'',False,False);
	   end;
	 end;

      6: begin
	   Sel2:=SelectFile(True,SelFile,'EDIT');
	   if (Sel2>0) then begin
	       Command:=GetEnv('EDITOR');
	       if Command='' then Command:=GetEnv('EDIT');
	       if Command='' then Command:='Notepad '+FilePar.Body[Sel2].Name
                             else Command:=Command+' '+FilePar.Body[Sel2].Name;
	       ExitCode:=Child(Command,'',False,False);
           end;
	 end;

      7: begin
           PullColor:=Color2.Menu2;
           SelectMenuSFirst(PWinX,PWinY+8,1,2,12,0,2);
           SelectMode(True,False,False,True);
           repeat
               Sel2:=SelectMenuSNext(ReadFileMenu,'','');
               case Sel2 of
                 0:Sel3:=SetFileParam(PWinX,PWinY+1,0,True);
                 1:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+2,1,1,12+5,0,1);
                     repeat
                         SetMenuVal(0,12+5,FileFormatMenu,DGSYS.FileOption,5,0);
                         Sel3:=SelectMenuSNext(FileFormatMenu,'','');
                         case Sel3 of
                           0: toggle(DGSYS.FileOption);
                         end;
                     until (Sel3<0);
                     SelectMenuSEnd;
                   end;
               end;
           until (Sel2<0);
           SelectMenuSEnd;
         end;

      8: begin
           PullColor:=Color2.WindowInput;
           Fil:=DGSYS.ActivDir;
           if WindowInput(PWinX,PWinY+9,30,Fil,'NEW DIRECTORY','') then begin
               if Fil[Length(Fil)]='\' then Delete(Fil,Length(Fil),1);
               ChDir(Fil);
               if not IOErrorCheck then GetDir(0,DGSYS.ActivDir);
           end;
        end;

      9: begin
           Command:=GetEnv('COMSPEC');
	   if Command='' then Command:='command.com';
	   ExitCode:=Child(Command,'',False,False);
         end;

     10: begin
          PullColor:=Color2.Setting;
          PullColor.Bar:=PullColor.Back;
          SelectMenuSFirst(PWinX,PWinY+11,1,7,32,0,7);
          SelectMenuSDisp(0,0,AboutMenu,'','');
          PullColor:=Color2.Setting;
          SelectMode(False,False,False,False);
          Ch:=WindowInputChar(PWinX,PWinY,'','','',[Chr(1)..Char($FF)]);
          SelectMenuSEnd;
        end;

     11: begin
          PullX:=PWinX;
          PullY:=PWinY+11;
          PullQuit;
        end;

       end;
end;

end.
