(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C|Print|j| *)

unit MPrint;

interface

uses JCType,PullMenu,Gra2Crt,Data,Math,
     Display,Variable,ChildExe,Dialog,IOProc,GUI,GDraw,DosCall;

Type Real=Double;

function PrintingBody(Sel:Integer):Boolean;

implementation

const
   RegionMenu: array [0..4] of String[18+5] =
       ('Left margin(.1mm):',
        'Top  margin(.1mm):',
        'Region size(.1mm):',
        'Determine all     ',
        'Preview           ');

   ConnectMenu :array [0..3] of String[18]=(
				   'PRINTER           ',
				   'RS232C            ',
				   'FILE(********.***)',
                                   'NULL              ' );

   DriverMenu : array [0..3] of String[12+30]=(
                  'Driver file:',
                  'Option     :',
                  'Description:',
                  'Delete      ');

   PrinterMenu: array [0..6] of String[44] =( '************ DATA FILE   f|^t@C    ',
                                              '************ .GRA FILE   OtBbNf|^',
                                              '',
					      '',
                                              '',
                                              '',
                                              '' );

   PrinterRedy ='v^|̏ĔCӂ̃L|Ă';
   RSRedy      ='RS232C̏ĔCӂ̃L|Ă';
   NULLRedy    ='ۂ̏o͍͂s܂DCӂ̃L|Ă';

function PrintingBody(Sel:Integer):Boolean;

        function Ready:Boolean;
        var Ch:Char;
        begin
          PullColor:=Color2.Verify2;
          case DGSYS.OutPutDevice of
               PRINTER: Ch:=WindowInputChar(PWinX,PWinY+4,PrinterRedy,'VERIFY','ESC:~',[Chr(1)..Char($FF)]);
                RS232C: Ch:=WindowInputChar(PWinX,PWinY+4,RSRedy,'VERIFY','ESC:~',[Chr(1)..Char($FF)]);
              TEXTFILE: Ch:=WindowInputChar(PWinX,PWinY+4,'t@C('+MakeFileName(DGSYS.OutPutFile)+')ɏo͂܂'
                            ,'VERIFY','ESC:~',[Chr(1)..Char($FF)]);
                  NULL: Ch:=WindowInputChar(PWinX,PWinY+4,NULLRedy,'VERIFY','ESC:~',[Chr(1)..Char($FF)]);
          end;
          if Ch=PullKey.ESC then Ready:=False
          else Ready:=True;
          if (DGSYS.OutPutDevice=TEXTFILE) and not (Ch=PullKey.ESC) then begin
              if Find(DGSYS.OutPutFile,false) and not (InputYN(PWinX,PWinY+4,Overwrite) in ['Y','y']) then
                  Ready:=False;
          end;
        end;

var i,a,Sel2,Sel3,fst,Minx,Size:Integer;
    xx,yy:array [0..1] of Integer;
    Error,Win:Boolean;
    S:String;
    fp:Text;
    x0,y0,x1,y1:Real;
    SelFile :ByteSet;
    GraphicOutFil:String;
    Menu:array [0..5] of String[12];
    Fil,Path:PathStr;
    ExitCode:Word;
    Dr:Boolean;
    OutSet:ByteSet;
    Lin:LongInt;
    NAN0,NAN1:Boolean;
begin
    if Sel=2 then SelectMode(True,True,False,True)
             else SelectMode(True,False,False,True);
    PrintingBody:=False;
    PullColor:=Color2.Menu2;
    if Sel>=0 then
          case Sel of
            0: begin
                 PullColor:=Color2.Setting;
                 SelectMenuSFirst(PWinX,PWinY+1,1,5,18+5,4,5);
                 repeat
                     SetMenuVal(0,18+5,RegionMenu,NGRAPH.LeftMargin,1,0);
                     SetMenuVal(1,18+5,RegionMenu,NGRAPH.TopMargin,1,0);
                     SetMenuVal(2,18+5,RegionMenu,NGRAPH.RegionSize,1,0);
                     Sel3:=SelectMenuSNext(RegionMenu,'','');
                     case Sel3 of
                       0:  ValInput(PWinX+19,PWinY+1,'NEW VALUE(0~2100/0.1mm)',NGRAPH.LeftMargin,1,0,2100);
                       1:  ValInput(PWinX+19,PWinY+2,'NEW VALUE(0~2970/0.1mm)',NGRAPH.TopMargin,1,0,2970);
                       2:  ValInput(PWinX+19,PWinY+3,'NEW VALUE(1~2100/0.1mm)',NGRAPH.RegionSize,1,1,2100);
                       3:  begin
                             ClrScr2;
                             StartGraph;
                             SetGauge2;
                             i:=0;
                             Size:=Round(PaperSize/297*210);
                             Minx:=Round((PaperSize-Size)*0.5);
                             xx[0]:=Mm2dot(NGRAPH.LeftMargin/297*210)+Minx;
                             yy[0]:=Mm2dot(NGRAPH.TopMargin/297*210);
                             xx[1]:=Mm2dot(NGRAPH.RegionSize/297*210);
                             yy[1]:=Mm2dot(NGRAPH.RegionSize/297*210);
                             repeat
                                 if i=0 then a:=InputPos('p̈ʒuw',True,False,False,xx[0],yy[0],xx[1],yy[1],1,
                                                         Minx,0,Minx+Size,PaperSize)
                                        else a:=InputPos('p̃TCYw',True,False,True,xx[1],yy[1],xx[0],yy[0],5,
                                                         Minx,0,Minx+Size,PaperSize);
                                 if (a=-2) and (i>0) then Dec(i)
                                 else if a>0 then Inc(i);
                             until (a=-1) or (i=2);
                             if (a<>-1) then begin
                                  NGRAPH.LeftMargin:=Dot2mm((xx[0]-Minx)/210*297);
                                  NGRAPH.TopMargin:=Dot2mm(yy[0]/210*297);
                                  NGRAPH.RegionSize:=Dot2mm(xx[1]/210*297);
                             end;
                             SetGauge2;
                             StopGraph;
                             ClearScreen;
                           end;
                       4:  begin
                              DGSYS.GraphicFil:=DGSYS.GRADIR+DGSYS.TEMPNAME+'.GRA';
                              DGSYS.Device:=1;
                              if FilePar.Num<>0 then begin
                                  Fst:=SelectFile(False,OutSet,'DRAW');
                                  if Fst<=0 then Fst:=-1;
                              end else begin
                                  Fst:=0;
                                  OutSet:=[];
                              end;
                              if (Fst>=0) and Draw(Fst,OutSet,False) and not KeyCheck then begin
                                  ExitCode:=Child(DGSYS.SYSTEMDIR+DGSYS.Previewer,DGSYS.GraphicFil+' DUMMY GRA2.EXE',True,True);
                                  ClearScreen;
                                  PrintingBody:=True;
                              end;
                           end;
                     end;
                     if NGRAPH.LeftMargin+NGRAPH.RegionSize>2100 then NGRAPH.RegionSize:=2100-NGRAPH.LeftMargin;
                     if NGRAPH.TopMargin+NGRAPH.RegionSize>2970 then NGRAPH.RegionSize:=2970-NGRAPH.TopMargin;
                     if NGRAPH.RegionSize<=0 then NGRAPH.RegionSize:=1;
                 until (Sel3<0) or (Sel3=4);
                 SelectMenuSEnd;
               end;
            1: begin
                 SelectMenuSFirst(PWinX,PWinY+2,1,6,12,0,6);
                 repeat
                     for i:=0 to 4 do Menu[i]:=MakeFileName(DRIVER[i].Name);
                     Menu[5]:='TEMP GRA DIR';
                     Sel2:=SelectMenuSNext(Menu,'','');
                     case Sel2 of
                       0..4:begin
                         PullColor:=Color2.Setting;
                         SelectMenuSFirst(PWinX,PWinY+Sel2+1,1,4,12+30,0,4);
                         repeat
                             SetMenuVal(0,12+30,DriverMenu,DRIVER[Sel2].Name,6,30);
                             SetMenuVal(1,12+30,DriverMenu,DRIVER[Sel2].Opt,6,30);
                             SetMenuVal(2,12+30,DriverMenu,DRIVER[Sel2].Note,6,30);
                             Sel3:=SelectMenuSNext(DriverMenu,'','');
                             case Sel3 of
                               0: begin
                                    Path:=DGSYS.SYSTEMDIR+'GRA2*.EXE';
                                    if GetFileName(PWinX+12,PWinY+1,Fil,Path,'.EXE','DRIVER NAME') then DRIVER[Sel2].Name:=Fil;
                                  end;
                               1: begin
                                    PullColor:=Color2.WindowInput;
                                    S:=DRIVER[Sel2].Opt;
                                    Win:=WindowInput(PWinX+12,PWinY+2,30,S,'COMMAND LINE OPTION','');
                                    DRIVER[Sel2].Opt:=S;
                                  end;
                               2: begin
                                    PullColor:=Color2.WindowInput;
                                    S:=DRIVER[Sel2].Note;
                                    Win:=WindowInput(PWinX+12,PWinY+3,31,S,'DESCRIPTION','');
                                    DRIVER[Sel2].Note:=S;
                                  end;
                               3: begin
                                    DRIVER[Sel2].Name:='';
                                    DRIVER[Sel2].Note:='';
                                  end;
                             end;
                         until (Sel3<0) or (Sel3=3);
                         SelectMenuSEnd;
                         end;
                       5:begin
                           PullColor:=Color2.WindowInput;
                           S:=DGSYS.GRADIR;
                           Delete(S,Length(S),1);
                           Win:=WindowInput(PWinX,PWinY+6,30,S,'NEW DIRECTORY','');
                           DGSYS.GRADIR:=S;
                           if DGSYS.GRADIR='' then DGSYS.GRADIR:='.';
                           i:=1;
                           While i<=Length(DGSYS.GRADIR) do begin
                             if not IsKanji(Ord(DGSYS.GRADIR[i])) then DGSYS.GRADIR[i]:=UpCase(DGSYS.GRADIR[i])
                                                                  else Inc(i);
                             Inc(i);
                           end;

                           if DGSYS.GRADIR[Length(DGSYS.GRADIR)]<>'\' then DGSYS.GRADIR:=DGSYS.GRADIR+'\';
                         end;
                     end;

                 until Sel2<0;
                 SelectMenuSEnd;
               end;
            2: begin
                ConnectMenu[2]:='FILE('+MakeFileName2(DGSYS.OutPutFile)+')';
                Sel2:=SelectAMenu(PWinX,PWinY+3,1,4,18,DGSYS.OutPutDevice,4,ConnectMenu,'','');
                if Sel2>=0 then begin
                    case Sel2 of
                      0:DGSYS.OutPutDevice:=PRINTER;
                      1:begin
//                          ExitCode:=Child('/c SPEED','',False,False);
                          DGSYS.OutPutDevice:=RS232C;
                        end;
                      2:begin
                          Path:=DGSYS.OutPutFile;
                          if GetFileName(PWinX,PWinY+3,Fil,Path,'.*','OUTPUT FILE') then begin
                              DGSYS.OutPutFile:=Fil;
                              DGSYS.OutPutDevice:=TEXTFILE;
                          end;
                        end;
                      3:DGSYS.OutPutDevice:=NULL;
                    end;
                end;
               end;

            3: begin
                 for i:=0 to 4 do PrinterMenu[2+i]:=MakeFileName(DRIVER[i].Name)+' '+DRIVER[i].Note;
                 Sel2:=SelectAMenu(PWinX,PWinY+4,1,7,44,0,7,PrinterMenu,'','');
                 PullColor:=Color2.Menu3;
                 if Sel2>=0 then begin
                       if (Sel2=0) and (FilePar.Num=0) then 
                           Verify(PWinX,PWinY+4,MustBeSet)
                       else
                           case Sel2 of
                               0:begin
                                   Path:='';
                                   if GetFileName(PWinX,PWinY+4,Fil,Path,'.*','DATA FILE') then begin
                                       if not Find(Fil,false) or (InputYN(PWinX,PWinY+4,Overwrite) in ['Y','y']) then begin
                                           fst:=SelectFile(True,SelFile,'FILE OUTPUT');
                                           if (FExpand(Fil)=FExpand(FilePar.Body[fst].Name)) then
                                               ErrorDisp('Error: Data file is same as output data file -> not output')
                                           else begin
                                               if OpenData(fst) then begin
                                                   Assign(fp,fil);
                                                   ReWrite(fp);
                                                   WriteLn(fp,'= = Creator:NGRAPH Origin:',
                                                           MakeFileName2(FilePar.Body[fst].Name));
                                                   AxisRawMode:=True;
                                                   While GetData(x0,y0,Lin,NAN0) do begin
                                                       if not (FilePar.Body[fst].DotTyp in [36..41]) then begin
                                                           if not NAN0 then WriteLn(fp,x0:15,', ',y0:15)
                                                       end else if GetData(x1,y1,Lin,NAN1) then begin
                                                           if not NAN0 and not NAN1 then
                                                               WriteLn(fp,x0:15,', ',y0:15,', ',x1:15,', ',y1:15);
                                                       end;
                                                   end;
                                                   CloseData;
                                                   Error:=IOErrorCheck;
                                                   Close(fp);
                                                   Error:=IOErrorCheck;
                                               end;
                                           end;
                                       end;
                                   end;
                                 end;
                               1:begin
                                   Path:='';
                                   if GetFileName(PWinX,PWinY+4,Fil,Path,'.GRA','GRA FILE') then begin
                                       DGSYS.GraphicFil:=Fil;
                                       if not Find(DGSYS.GraphicFil,false)
                                        or (InputYN(PWinX,PWinY+4,Overwrite) in ['Y','y']) then begin
                                           DGSYS.Device:=1;
                                           if FilePar.Num<>0 then begin
                                               Fst:=SelectFile(False,OutSet,'DRAW');
                                               if Fst<=0 then Fst:=-1;
                                           end else begin
                                               Fst:=0;
                                               OutSet:=[];
                                           end;
                                           if Fst>=0 then Dr:=Draw(Fst,OutSet,False);
                                           PrintingBody:=True;
                                       end;
                                   end;
                                 end;
                            2..6:if (Length(DRIVER[Sel2-2].Name)<>0) then begin
                                     if FilePar.Num<>0 then begin
                                         Fst:=SelectFile(False,OutSet,'DRAW');
                                         if Fst<=0 then Fst:=-1;
                                     end else begin
                                         Fst:=0;
                                         OutSet:=[];
                                     end;
                                     if (Fst>=0) and Ready then begin
                                         DGSYS.GraphicFil:=DGSYS.GRADIR+DGSYS.TEMPNAME+'.GRA';
                                         case DGSYS.OutputDevice of
                                            PRINTER:  GraphicOutFil:='PRN';
                                            RS232C:   GraphicOutFil:='AUX';
                                            TEXTFILE: GraphicOutFil:=DGSYS.OutPutFile;
                                            NULL:     GraphicOutFil:='NUL';
                                         end;
                                         DGSYS.Device:=1;
                                         if Draw(Fst,OutSet,False) and not KeyCheck then begin
                                             if Child(DRIVER[Sel2-2].Name,
                                             DGSYS.GraphicFil+' '+GraphicOutFil+' '+DRIVER[Sel2-2].Opt,True,True)<>0 then begin
                                                 ClearScreen;
                                             end;
                                         end;
                                         PrintingBody:=True;
                                       end;
                                     end;
                           end;
                 end;
               end;
          end;
end;

end.
