(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱Cp^C *)

unit PRMIn;

interface

uses PullMenu,Variable,IOProc,Display,SysUtils,DosCall;

Type Real=Double;

procedure ParamIn(Fil:PathStr);

implementation

procedure GetTimeVal(Str:String;var T:TDateTime);
var Str2:String;
    Po,code:Integer;
    Year,Month,Day:Word;
    Hour,Min,Sec,MSec:Word;
begin
    Po:=Pos('-',Str);
    Str2:=Copy(Str,1,Po-1);
    Val(Str2,Year,code);
    Delete(Str,1,Po);
    Po:=Pos('-',Str);
    Str2:=Copy(Str,1,Po-1);
    Val(Str2,Month,code);
    Delete(Str,1,Po);
    Po:=Pos(' ',Str);
    Str2:=Copy(Str,1,Po-1);
    Val(Str2,Day,code);
    Delete(Str,1,Po);
    Po:=Pos(':',Str);
    Str2:=Copy(Str,1,Po-1);
    Val(Str2,Hour,code);
    Delete(Str,1,Po);
    Po:=Pos(':',Str);
    Str2:=Copy(Str,1,Po-1);
    Val(Str2,Min,code);
    Delete(Str,1,Po);
    Val(Str,Sec,code);
    MSec:=0;
    T:=EncodeDate(Year,Month,Day)+EncodeTime(Hour,Min,Sec,MSec);
end;

procedure ParamIn(Fil:PathStr);
var c1,c2,c3:longint;
    fp,fp2:text;
    i,j:integer;
    Str,Str2:String;
    Error:Boolean;
    FilName:PathStr;
    Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
    FileType,Po:Integer;
    Time:LongInt;
    T:TDateTime;
    Ch:Char;
    MakeData:Boolean;
    H:Integer;
begin
     FWild(Fil,Dir,Name,Ext,'.PRM');
     if Find(Fil,True) then begin
	  Assign(fp,fil);
	  Reset(fp);
          ReadLn(fp,Str);
          if (Str=(DGSYS.Main+Ver2+'  '+DGSYS.PRMtitle)) then FileType:=2
          else if (Str=(DGSYS.Main+DGSYS.Ver+'  '+DGSYS.PRMtitle)) then FileType:=3
          else if (Str=(DGSYS.Main+Ver2+'  '+DGSYS.DPMtitle)) then FileType:=12
          else if (Str=(DGSYS.Main+DGSYS.Ver+'  '+DGSYS.DPMtitle)) then FileType:=13
          else FileType:=0;
          if FileType<>0 then begin
	    ReadLn(fp,FilePar.Num);
	    j:=0;
	    for i:=1 to FilePar.Num do With FilePar.Body[j+1] do begin
                ReadLn(fp,Name);
                ReadLn(fp,hax,vax,Axisx,Axisy,DotTyp,DotAttr,
                          DotWidth,DotCol,DotSize,DottedSize);
                Readln(fp,SkipNum,ReadStep,FinalLine,Smoothingx,Smoothingy);
                ReadLn(fp,LeastMode,Lx,Ly);
                ReadLn(fp,ModX);
                ReadLn(fp,ModY);
                IsRead:=False;
                DotNum:=-2;
                if FileType in [12,13] then Name:=DGSYS.TEMPDIR+MakeFileName2(Name);
                if (FileType in [12,13]) or Find(Name,True) then begin
                   Name:=FExpand(Name);
                   Comment:='';
                   Inc(j);
                end;
            end;
	    FilePar.Num:=j;

            With LSQPar do begin
                ReadLn(fp,FitError);
                ReadLn(fp,FitDif);
                for i:=1 to 7 do ReadLn(fp,FitVal[i]);
                for i:=0 to 7 do ReadLn(fp,FitExp[i]);
            end;

            With NGRAPH do begin
                ReadLn(fp,GraphTyp,TopMargin,LeftMargin,RegionSize,ViewX1,ViewY1,Sizex,Sizey);
                ReadLn(fp,DrawMode[0],DrawMode[1],DrawMode[2],Con00);
                ReadLn(fp,Aattr[0],Aattr[1],Aattr[2],Aattr[3],Aattr[4],Aattr[5],Aattr[6]);
                ReadLn(fp,ASattr[0],ASattr[1],ASattr[2],ASattr[3],ASattr[4],ASattr[5],ASattr[6]);
                for i:=0 to 1 do ReadLn(fp,UserFn[i]);
            end;

            With Mask do begin
               ReadLn(fp,Num);
               for i:=1 to 20 do With Body[i] do ReadLn(fp,Fil,Lin,x,y);
            end;

            With MaskReg do begin
               ReadLn(fp,Num);
               for i:=1 to 20 do With Body[i] do ReadLn(fp,Fil,Mx1,Mx2,My1,My2);
            end;

            if FileType in [3,13] then With ChgData do begin
               ReadLn(fp,Num);
               for i:=1 to 20 do With Body[i] do ReadLn(fp,Fil,Lin,x,y);
            end;

            for i:=0 to 5 do With Title[i] do begin
	       ReadLn(fp,Str);
	       ReadLn(fp,x,y);
	    end;

	    for i:=1 to 20 do With Remark[i] do begin
	       ReadLn(fp,Str);
	       ReadLn(fp,x,y,dir);
	    end;

	    for i:=1 to 20 do With Arrow[i] do begin
	       ReadLn(fp,sx,sy,ex,ey,Len,Attr,Width,Col,c1);
	       Act:=Boolean(c1);
	    end;

            for i:=1 to 20 do With Dot[i] do begin
               for j:=0 to 9 do Readln(fp,x[j],y[j]);
               Readln(fp,Attr,Width,Typ,Col,ActivNum,DotSize,DottedSize);
            end;

            for i:=0 to 3 do With AxisPar[i] do begin
                ReadLn(fp,Min,Max,Scale,c1,c2,c3);
                SetMin:=Boolean(c1);
                SetMax:=Boolean(c2);
                SetScale:=Boolean(c3);
                ReadLn(fp,ScType);
                ReadLn(fp,ScDiv,ScMode,ScFull,ScCros,ScAuto,ScNum,ScStart,ScStep,ScFig,ScZero,ScPlus,ScPer);
                ReadLn(fp,ScPosS,ScPosE,ScDir,ScLR,ScLog,ScPosx,ScPosy);
                ReadLn(fp,Lattr[0],Lattr[1],Lattr[2],Lattr[3],Lattr[4]);
                ReadLn(fp,Lwidth[0],Lwidth[1],Lwidth[2],Lwidth[3],Lwidth[4]);
                ReadLn(fp,Lcol[0],Lcol[1],Lcol[2],Lcol[3],Lcol[4]);
                ReadLn(fp,LLen[1],LLen[2],LLen[3]);
            end;

            for i:=0 to 9 do With Merge[i] do begin
               ReadLn(fp,Fil);
               if (Length(Fil)<>0) and (FileType in [12,13]) then Fil:=DGSYS.TEMPDIR+MakeFileName2(Fil);
               ReadLn(fp,x,y,Size);
            end;

            if FileType in [12,13] then While not Eof(fp) do begin
                ReadLn(fp,Str);
                if (Str[1]='[') then begin
                  Po:=Pos(']',Str);
                  Str2:=Str;
                  FilName:=DGSYS.TEMPDIR+Copy(Str,2,Po-2);
                  if not Find(FilName,False)
                  or (InputYN(PWinX,PWinY+3,'File('+FilName+') exist. Overwrite Ok? (Y/N)') in ['Y','y']) then 
                       MakeData:=True
                  else MakeData:=False;
                  if MakeData then begin
                      Assign(fp2,FilName);
                      Rewrite(fp2);
                  end;
                  i:=1;
                  While (not EOF(fp)) and (i<10) do begin
                      Read(fp,Ch);
                      if Ch=EOD[i] then Inc(i)
                      else begin 
                          if MakeData then for j:=1 to i-1 do Write(fp2,EOD[j]);
                          i:=1;
                          if Ch=EOD[i] then Inc(i)
                          else if MakeData then Write(fp2,Ch);
                      end;
                  end;
                  if MakeData then begin
                      Close(fp2);
                      H:=FileOpen(FilName,fmOpenWrite);
                      Delete(Str2,1,Po+1);
                      GetTimeVal(Str2,T);
                      Time:=DateTimeToFileDate(T);
                      FileSetDate(H,Time);
                      FileClose(H);
                  end;
                  Error:=IOErrorCheck;
                end;
            end;
            DGSYS.ParamFile:=Fil;

	  end else ErrorDisp('Error: Incompatible PRM file('+fil+')');
          Error:=IOErrorCheck;
	  Close(fp);
	  Error:=IOErrorCheck;
     end;
end;

end.