(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I[oC葱Cp^AEg *)

unit PRMOut;

interface

uses Display,Variable,IOProc,DosCall,SysUtils;

Type Real=Double;

procedure ParamOut(fil:PathStr);

implementation

procedure ParamOut(fil:PathStr);
var fp,fp2:text;
    i,j:integer;
    Error,SameFull,SameName:Boolean;
    Str:String;
    Ch:Char;
    Time:LongInt;
    T:TDateTime;
    H:Integer;
    Year,Month,Day,Hour,Min,Sec,MSec:Word;
begin
    Assign(fp,fil);
    Rewrite(fp);
    if DGSYS.DPMOut[1]='Y' then WriteLn(fp,DGSYS.Main+DGSYS.Ver+'  '+DGSYS.DPMtitle)
                           else WriteLn(fp,DGSYS.Main+DGSYS.Ver+'  '+DGSYS.PRMtitle);
    WriteLn(fp,FilePar.Num);
    for i:=1 to FilePar.Num do With FilePar.Body[i] do begin
       if DGSYS.FullPath[1]='Y' then WriteLn(fp,Name)
                                else WriteLn(fp,MakeFileName2(Name));
       WriteLn(fp,hax,' ',vax,' ',Axisx,' ',Axisy,' ',DotTyp,' ',DotAttr,' ',
                  DotWidth,' ',DotCol,' ',DotSize,' ',DottedSize);
       WriteLn(fp,SkipNum,' ',ReadStep,' ',FinalLine,' ',Smoothingx,' ',Smoothingy);
       WriteLn(fp,LeastMode,' ',Lx,' ',Ly);
       WriteLn(fp,ModX);
       WriteLn(fp,ModY);
    end;

    With LSQPar do begin
        WriteLn(fp,FitError);
        WriteLn(fp,FitDif);
        for i:=1 to 7 do WriteLn(fp,FitVal[i]);
        for i:=0 to 7 do WriteLn(fp,FitExp[i]);
    end;

    With NGRAPH do begin
        WriteLn(fp,GraphTyp,' ',TopMargin,' ',LeftMargin,' ',RegionSize,' ',ViewX1,' ',ViewY1,' ',Sizex,' ',Sizey);
        WriteLn(fp,DrawMode[0],DrawMode[1],DrawMode[2],Con00);
        WriteLn(fp,Aattr[0],Aattr[1],Aattr[2],Aattr[3],Aattr[4],Aattr[5],Aattr[6]);
        WriteLn(fp,ASattr[0],ASattr[1],ASattr[2],ASattr[3],ASattr[4],ASattr[5],ASattr[6]);
        for i:=0 to 1 do WriteLn(fp,UserFn[i]);
    end;

    With Mask do begin
       WriteLn(fp,Num);
       for i:=1 to 20 do With Body[i] do WriteLn(fp,Fil,' ',Lin,' ',x,' ',y);
    end;

    With MaskReg do begin
       WriteLn(fp,Num);
       for i:=1 to 20 do With Body[i] do WriteLn(fp,Fil,' ',Mx1,' ',Mx2,' ',My1,' ',My2);
    end;

    With ChgData do begin
       WriteLn(fp,Num);
       for i:=1 to 20 do With Body[i] do WriteLn(fp,Fil,' ',Lin,' ',x,' ',y);
    end;

    for i:=0 to 5 do With Title[i] do begin
       WriteLn(fp,Str);
       WriteLn(fp,x,' ',y);
    end;

    for i:=1 to 20 do With Remark[i] do begin
       WriteLn(fp,Str);
       WriteLn(fp,x,' ',y,' ',dir);
    end;

    for i:=1 to 20 do With Arrow[i] do begin
       WriteLn(fp,sx,' ',sy,' ',ex,' ',ey,' ',Len,' ',Attr,' ',Width,' ',Col,' ',Ord(Act));
    end;

    for i:=1 to 20 do With Dot[i] do begin
       for j:=0 to 9 do WriteLn(fp,x[j],' ',y[j]);
       WriteLn(fp,Attr,' ',Width,' ',Typ,' ',Col,' ',ActivNum,' ',DotSize,' ',DottedSize);
    end;

    for i:=0 to 3 do With AxisPar[i] do begin
        WriteLn(fp,Min,' ',Max,' ',Scale,' ',Ord(SetMin),' ',Ord(SetMax),' ',Ord(SetScale));
        WriteLn(fp,ScType);
        WriteLn(fp,ScDiv,ScMode,ScFull,ScCros,ScAuto,ScNum,ScStart,ScStep,ScFig,ScZero,ScPlus,ScPer);
        WriteLn(fp,ScPosS,' ',ScPosE,' ',ScDir,' ',ScLR,' ',ScLog,' ',ScPosx,' ',ScPosy);
        WriteLn(fp,Lattr[0],' ',Lattr[1],' ',Lattr[2],' ',Lattr[3],' ',Lattr[4]);
        WriteLn(fp,Lwidth[0],' ',Lwidth[1],' ',Lwidth[2],' ',Lwidth[3],' ',Lwidth[4]);
        WriteLn(fp,Lcol[0],' ',Lcol[1],' ',Lcol[2],' ',Lcol[3],' ',Lcol[4]);
        WriteLn(fp,LLen[1],' ',LLen[2],' ',LLen[3]);
    end;

    for i:=0 to 9 do With Merge[i] do begin
       if DGSYS.FullPath[1]='Y' then WriteLn(fp,Fil)
                                else WriteLn(fp,MakeFileName2(Fil));
       WriteLn(fp,x,' ',y,' ',Size);
    end;

if DGSYS.DPMOut[1]='Y' then begin
    for i:=1 to FilePar.Num do begin
       SameFull:=False;
       SameName:=False;
       for j:=i-1 downto 1 do begin
         if Fexpand(FilePar.Body[i].Name)=Fexpand(FilePar.Body[j].Name) then SameFull:=True;
         if MakeFileName2(FilePar.Body[i].Name)=MakeFileName2(FilePar.Body[j].Name) then SameName:=True;
       end;
       if not SameFull then begin
         if SameName then ErrorDisp('Error: Same filename('+FilePar.Body[i].Name+')');
         if Find(FilePar.Body[i].Name,True) then begin
           H:=FileOpen(FilePar.Body[i].Name,fmOpenRead);
           Time:=FileGetDate(H);
           T:=FileDateToDateTime(Time);
           FileClose(H);
           DecodeDate(T,Year,Month,Day);
           DecodeTime(T,Hour,Min,Sec,MSec);
           Assign(fp2,FilePar.Body[i].Name);
           Reset(fp2);
           WriteLn(fp,'['+MakeFileName2(FilePar.Body[i].Name)+'] ',
                      Year,'-',Month,'-',Day,' ',Hour,':',Min,':',Sec);
           While not EOF(fp2) and not IOErrorCheck do begin
               Read(fp2,Ch);
               Write(fp,Ch);
           end;
           Write(fp,EOD);
           Error:=IOErrorCheck;
           Close(fp2);
           Error:=IOErrorCheck;
         end;
       end;
    end;
    for i:=0 to 9 do if Length(Merge[i].Fil)<>0 then begin
       SameFull:=False;
       SameName:=False;
       for j:=i-1 downto 0 do begin
         if Fexpand(Merge[i].Fil)=Fexpand(Merge[j].Fil) then SameFull:=True;
         if MakeFileName2(Merge[i].Fil)=MakeFileName2(Merge[j].Fil) then SameName:=True;
       end;
       if not SameFull then begin
         if SameName then ErrorDisp('Error: Same filename('+Merge[i].Fil+')');
         if Find(Merge[i].Fil,True) then begin
           H:=FileOpen(Merge[i].Fil,fmOpenRead);
           Time:=FileGetDate(H);
           T:=FileDateToDateTime(Time);
           FileClose(H);
           DecodeDate(T,Year,Month,Day);
           DecodeTime(T,Hour,Min,Sec,MSec);
           Assign(fp2,Merge[i].Fil);
           Reset(fp2);
           WriteLn(fp,'['+MakeFileName2(Merge[i].Fil)+'] ',
                      Year,'-',Month,'-',Day,' ',Hour,':',Min,':',Sec);
           While not EOF(fp2) and not IOErrorCheck do begin
               Read(fp2,Ch);
               Write(fp,Ch);
           end;
           Write(fp,EOD);
           Error:=IOErrorCheck;
           Close(fp2);
           Error:=IOErrorCheck;
         end;
       end;
    end;
end;

    Error:=IOErrorCheck;
    Close(fp);
    Error:=IOErrorCheck;
    DGSYS.ParamFile:=Fil;
end;


end.