(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* ϐ錾 *)

unit Variable;

interface

uses Pullmenu,Math,DosCall;

Type Real=Double;

const

    maxfil=20;
//    DataBuffer=256;
    DataBuffer=1024;

    PRINTER=0;
    RS232C=1;
    TEXTFILE=2;
    NULL=3;

Type
    DGQuitProc=procedure(Mes:String);
    Str4  = String[4];
    Str8  = String[8];
    Str10 = String[10];
    Str20 = String[20];
    ComStr = String;
    GraphDataType   = array[0..DataBuffer-1] of Real;
    LPosType        = array[0..DataBuffer-1] of LongInt;
    GStattype       = array[0..DataBuffer-1] of ShortInt;
    SplineDataType  = array[0..DataBuffer-1] of Real;

    ByteSet  = Set of Byte;
    FileLineType = Array[1..1024] of Char;
    MathCodeType = Array[0..1023] of Char;
    MathDataType = Array[0..99] of Real;
    MathStatusType=Array[0..99] of ShortInt;
    MemoryDataType = Array[0..9] of Real;
    MemoryArrayType = Array[1..4] of MemoryDataType;
    DefFirstType = Array[0..9] of Boolean;
    DefArrayType = Array [1..4] of DefFirstType;



(* SYSTEM RECORD VARIABLE *)


Type  DGSYSType = record
                 Main :String[8];
                 Ver  :String[8];
                 Ver2 :Char;
                 Ver3 :Char;
                 HiResolution:Boolean;
                 CrtMode     :Word;
                 INItitle :String[8];
                 PRMtitle :String[8];
                 DPMtitle :String[8];
                 GRAtitle :String[8];
                 Copyright:String[36];
                 SYSTEMDIR   :PathStr;
                 SYSTEMNAME  :PathStr;
                 TEMPDIR     :PathStr;
                 TEMPNAME    :PathStr;
                 GRADIR      :PathStr;
                 DataBufSize :Word;
                 DataBufSeg  :Word;
                 MaximData   :Integer;
                 SPMaximData :Integer;
                 GraphicFil  :PathStr;
                 Device      :Integer;
                 OutPutDevice:Integer;
                 Resolution  :Integer;
                 AutoRun     :Boolean;
                 FullPath    :Str4;
                 DPMOut      :Str4;
                 FileOption  :Str4;
                 ActivDir    :PathStr;
                 Previewer   :PathStr;
                 OutPutFile  :PathStr;
                 ParamFile   :PathStr;
                 Quit        :procedure;
                 GraphicFp   :Text;
               end;

(* GRAPH PArAMETER *)

Type NGRAPHType = record
                 Drawn     :Boolean;
                 GraphTyp  :Integer;
                 TopMargin :Integer;
                 LeftMargin:Integer;
                 RegionSize:Integer;
                 ViewX1    :Integer;
                 ViewY1    :Integer;
                 Sizex     :Integer;
                 Sizey     :Integer;
                 DrawMode  :array [0..2] of Str4;
                 Con00     :Str4;
                 Aattr     :array[0..6] of Str20;
                 ASattr    :array[0..6] of Str20;
                 UserFn    :array[0..1] of String;
               end;

(* DRIVER RECORD VARIABLE *)

Type DRIVERType = array [0..4] of record
                 Name:PathStr;
                 Opt:ComStr;
                 Note:String[30];
               end;

(* ADD-IN RECORD VARIABLE *)

Type VAFType = record
              Prolog: array [0..2] of PathStr;
              Draw  : array [0..2] of PathStr;
              Epilog: array [0..2] of PathStr;
              Menu  : array [0..14] of PathStr;
            end;

(* FILE PARAMETER *)

Type FileParType = record
                  Num:Integer;
                  Body:array [0..21] of record
                      Name                         :PathStr;
                      hax,vax                      :Integer;
                      Axisx,Axisy                  :Integer;
                      DotTyp,DotAttr,DotWidth,DotCol,DotSize,DottedSize:Integer;
                      ReadStep                     :Integer;
                      SmoothingX,SmoothingY        :Integer;
                      DotNum,SkipNum,FinalLine     :LongInt;
                      Comment                      :String[29];
                      IsRead                       :Boolean;
                      LeastMode                    :Integer;
                      Lx,Ly                        :Real;
                      ModX,ModY                    :String;
                  end;
                end;

Type LSQParType = record
                   Typ:Integer;
                   Dim:Integer;
                   Coe:Vector;
                   CoeError:Vector;
                   ExitCode:LongInt;
                   Correlation:Real;
                   Error:Real;
                   FitError:Real;
                   FitDif:Str4;
                   FitVal:array[1..7] of Real;
                   FitExp:array[0..7] of String;
                end;

(* AXIS RECORD VARIABLE *)

Type AxisParBody= record
                    Min,Max,Scale :Real;
                    SetMin,SetMax,SetScale :Boolean;
                    ScType :Integer;
                    ScDiv,ScMode,ScFull,ScCros,ScAuto,ScNum,ScStart,ScStep,ScFig,ScZero,ScPlus,ScPer:Str4;
                    ScPosS,ScPosE,ScDir,ScLR,ScLog,ScPosx,ScPosy:Integer;
                    Lattr  :array [0..4] of Integer;
                    LWidth :array [0..4] of Integer;
                    Lcol   :array [0..4] of Integer;
                    LLen   :array [1..3] of Integer;
                  end;

Type AxisParType = array[0..3] of AxisParBody;

(* MASK RECORD VALIABLE *)

Type MaskType = Record
                  Num:Integer;
                  Body:Array [0..20] of Record
                    Fil:Integer;
                    Lin:LongInt;
                    x,y:Real;
                  end;
                end;

Type MaskRegType = Record
                  Num:Integer;
                  Body:Array [0..20] of Record
                    Fil:Integer;
                    Mx1,My1,Mx2,My2:Real;
                  end;
                end;

(* MERGE RECORD VARIABLE *)

Type MergeType = array [0..10] of record
                Fil:PathStr;
                X,Y,Size:Integer;
              end;

(* LEGEND-TITLE RECORD VARIABLE *)

Type TitleType = array [0..5] of record
		x,y  :Integer;
                Str  :String;
	     end;

(* LEGEND-TEXT RECORD VARIABLE *)

Type RemarkTypeBody = record
		x,y :Integer;
		dir :Integer;
		Str :String;
              end;

Type RemarkType =array [0..20] of RemarkTypeBody;

(* LEGEND-ARROW RECORD VARIABLE *)

Type ArrowTypeBody = record
	       sx,sy,ex,ey :Integer;
               Attr,Width,Len:Integer;
               Col :Integer;
               Act :Boolean;
             end;

Type ArrowType =array [0..20] of ArrowTypeBody;

(* LEGEND-DOT RECORD VARIABLE *)

Type DotTypeBody = record
             x,y:array[0..9] of Integer;
             Attr,Width,Typ,Col,Activnum,DotSize,DottedSize:Integer;
           end;

Type DotType =array [0..20] of DotTypeBody;

Type ColorType = record
                Message2:array [0..6] of Word;
                Param  :array [0..3] of Word;
                Graphic:array [0..5] of Word;
                MainMenu,Menu,Menu2,Menu3,Setting,Setting2,Directory,
                WindowInput,Verify,Verify2,SelFile,FileDisp,Error :PullMenuColor;
              end;
Var
    gx,gy,gx2,gy2: ^GraphDataType;
    LPos :^LPosType;
    gStat:^GStatType;
    spx,spy,spz,c1,c2,c3,c4,c5,c6   : ^SplineDataType;
    FileLine:^FileLineType;
    MathCodex,MathCodey:^MathCodeType;
    MathData:^MathDataType;
    MMemory,IntegData,DefData :^MemoryArrayType;
    DefFirst  :^DefArrayType;
    LSQMathCode:Array [0..7] of ^MathCodeType;
    UserFnCode:Array [0..1] of ^MathCodeType;
    AxisPar2 : ^AxisParType;

    DGSYS   : DGSYSType;
    NGRAPH  : NGRAPHType;
    DRIVER  : DRIVERType;
    VAF     : VAFType;
    FilePar : FileParType;
    LSQPar  : LSQParType;
    AxisPar : AxisParType;
    Mask    : MaskType;
    MaskReg : MaskRegType;
    ChgData : MaskType;
    Merge   : MergeType;
    Title   : TitleType;
    Remark  : RemarkType;
    Arrow   : ArrowType;
    Dot     : DotType;
    Color2  : ColorType;

    DGQuit  : DGQuitProc;

Const

   MustBeDrawn :String[16]='`悵Ă';
   MustBeSet   :String[26]='t@Cݒ肵Ă';
   HitAny      :String[11]='Hit any key';
   OverWrite   :String[19]='Overwrite Ok? (Y/N)';
   Ver2 :String[8] =' ver 5.2';
   EOD :String[9]=#13#10'[EOF]'#13#10;
   WinErrorDisp:Boolean=True;

   LineMenu : array [0..3] of String[10]= ( '0:',
					    '1:cccc',
					    '2:--------',
					    '3:----' );

   WidthMenu : array [0..2] of String[10]= ('(20)',
					    '(40)',
					    'Manual    ');

   ColMenu :array [0..7] of String[10]=(
				   '0: BLACK  ',
				   '1: BLUE   ',
				   '2: GREEN  ',
				   '3: CYAN   ',
				   '4: RED    ',
				   '5: MAGENTA',
				   '6: YELLOW ',
				   '7: WHITE  ');


implementation

end.
